   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Eines.ImageFileView;
   import Entitats.Eines.ImageFilter;
   import Entitats.Eines.ImagePreview;
   import Entitats.Eines.Fitxer;
   import Entitats.Eines.Cadena;
   import Entitats.Eines.CopiaFitxer;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder crear una nova pesa
*@author Jordi Moles i Blanco, Maig 2005
*/

   public class ControlAltaPesa
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
      String nomPesa,duradaPesa,procedenciaPesa,autorPesa,dataCreacioPesa,descripcioPesa;
      boolean altaSenseProblemes;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre afegir peces al sistema. 
   */
      public ControlAltaPesa()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_altaPesa.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlAltaPesa()
      {
      
         pantalla=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaAltaPesa()
      {
      
         JButton acceptar,cancelar,obrir,afegir;
      
         final Fitxer arxiu = new Fitxer();
         final Fitxer directoriDesti = new Fitxer();
         final Fitxer fitxerDesti = new Fitxer();
      
         final Cadena rutaImatge = new Cadena();
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaNovesDades();
                                          if(altaSenseProblemes)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("altaPesa"))).dispose();
                                             Pesa pesa = new Pesa();
                                             pesa.estableixNom(nomPesa);
                                             if(duradaPesa.compareToIgnoreCase("")!=0) pesa.estableixDurada(duradaPesa);
                                             if(procedenciaPesa.compareToIgnoreCase("")!=0) pesa.estableixProcedencia(procedenciaPesa);
                                             pesa.estableixAutor(autorPesa);
                                             if(dataCreacioPesa.compareToIgnoreCase("")!=0) pesa.estableixDataCreacio(dataCreacioPesa);
                                             if(descripcioPesa.compareToIgnoreCase("")!=0) pesa.estableixDescripcio(descripcioPesa);
                                             if(rutaImatge.obteCadena()!="")
                                             {
                                                RelacioImatges relIm = new RelacioImatges();
                                                Imatge imatge = new Imatge();
                                                imatge.estableixRuta(rutaImatge.obteCadena());
                                                pesa.estableixImatge(relIm.afegirImatge(imatge));   
                                             }
                                          
                                          
                                             int valorIntIDPesa=RelacioPeces.afegirPesa(pesa);
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()    
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae) 
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("operacioOK"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {   
                                                
                                                   System.err.println("(ControlAltaPesa1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             pesa.destructorPesa();
                                             docFile4=null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("altaPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
            obrir=(JButton)(pantalla.getObject("obrir"));
         
            obrir.addActionListener(                                                        
                                 
                                 
                                    new ActionListener()                                                
                                    
                                    {                                  
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)                                         
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                             JFileChooser fc;
                                             fc = new JFileChooser();
                                          
                                             fc.addChoosableFileFilter(new ImageFilter());
                                             fc.setAcceptAllFileFilterUsed(false);
                                          
                                             fc.setFileView(new ImageFileView());
                                          
                                             fc.setAccessory(new ImagePreview(fc));
                                          
                                          
                                             int returnVal = fc.showDialog((JFrame)(pantalla.getObject("altaPesa")),"Afegir");
                                          
                                             if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File directori = fc.getCurrentDirectory();
                                                arxiu.estableixFitxer(fc.getSelectedFile());
                                                String fitxer = arxiu.obteFitxer().getName();
                                                ((JTextField)(pantalla.getObject("nomImatge"))).setText(fitxer);
                                             
                                                directoriDesti.estableixFitxer(new File("../Galeria/peces/imatges/"));
                                                fitxerDesti.estableixFitxer(new File(directoriDesti.obteFitxer(), arxiu.obteFitxer().getName()));
                                                rutaImatge.estableixCadena("../Galeria/peces/imatges/"+arxiu.obteFitxer().getName());
                                             
                                             } 
                                          
                                             fc.setSelectedFile(null);
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {        
                                             
                                             
                                             
                                             
                                             
                                                System.err.println("(ControlAltaPesa2)Error: " + e.getMessage());
                                             
                                             }
                                       
                                       }
                                    
                                    });		
         
              ///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            afegir=(JButton)(pantalla.getObject("afegir"));
         
            afegir.addActionListener(
                                 
                                 
                                    new ActionListener()    
                                    
                                    
                                    
                                    {
                                    
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                          
                                             if(arxiu.obteFitxer()!=null)
                                             {
                                                Long checksumSrc = CopiaFitxer.copia(arxiu.obteFitxer(), fitxerDesti.obteFitxer());
                                             
                                                Long checksumDest = CopiaFitxer.creaChecksum(fitxerDesti.obteFitxer());
                                                if (!checksumSrc.equals(checksumDest)) {
                                                   System.err.println("(ControlAltaPesa3)Error: La copia del fitxer "+arxiu.obteFitxer().getName()+" ha fallat");
                                                }
                                                else
                                                {
                                                
                                                   Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(rutaImatge.obteCadena()));	
                                                   img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
                                                
                                                   ((JButton)(pantalla.getObject("imatge"))).setIcon(new ImageIcon(img));
                                                
                                                } 
                                             }
                                             else throw new Exception ("Encara no has seleccionat cap fitxer!!");
                                          
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {                                                     
                                             
                                             
                                                System.err.println("(ControlAltaSoci4)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlAltaPesa5)Error: " + e.getMessage());
            
            } 
      
      }
   
      private void capturaIValidaNovesDades()
      {
      
         altaSenseProblemes = true;
      
         nomPesa=((JTextField)(pantalla.getObject("valorNom"))).getText();
         duradaPesa=((JTextField)(pantalla.getObject("valorDurada"))).getText();
         procedenciaPesa=((JTextField)(pantalla.getObject("valorProcedencia"))).getText();
         autorPesa=((JTextField)(pantalla.getObject("valorAutor"))).getText();
         dataCreacioPesa=((JTextField)(pantalla.getObject("valorDataCreacio"))).getText();
         descripcioPesa=((JTextArea)(pantalla.getObject("valorDescripcio"))).getText();
      
         //validar dades
      
         if(nomPesa.compareToIgnoreCase("")==0)
         { 
            altaSenseProblemes=false;
         }
         else
            if(!ValidadorFormulariEntrada.validaNom(nomPesa)) 
            {
               altaSenseProblemes=false;
            }
      
         if(autorPesa.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaNom(autorPesa))
            { 
               altaSenseProblemes=false;
            }
      
         if(duradaPesa.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaDurada(duradaPesa)) altaSenseProblemes=false;
         else
         {
         
            if(procedenciaPesa.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaNom(procedenciaPesa)) altaSenseProblemes=false;
            else
            {
            
               if(dataCreacioPesa.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaData(dataCreacioPesa)) altaSenseProblemes=false;
               else
               {
               
                  if(descripcioPesa.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaDescripcio(descripcioPesa)) altaSenseProblemes=false;
               
               }
            
            }
         
         }
         if(altaSenseProblemes==false)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_error.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
            JLabel mis1,mis2;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
            
               pantalla2.load();
               pantalla2.renderInterface();
            
               mis1=(JLabel)(pantalla2.getObject("mis1"));
               mis2=(JLabel)(pantalla2.getObject("mis2"));
            
               mis1.setText("Dades incorrectes: Nom i autor son dades obligatories."); 
               mis2.setText("Durada i data creacio s'han d'introdur amb el format entre parentesis");
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                    
                                    
                                       new ActionListener()    
                                       
                                       
                                       {
                                       
                                       
                                       
                                          public void actionPerformed(ActionEvent ae) 
                                          
                                          
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("error"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
            
            
               catch(Exception e) {        
               
               
               
                  System.err.println("(ControlAltaPesa6)Error: " + e.getMessage());
               
               }
         
            docFile2=null;
         
         }
      
      }
   
   }