   package Entitats.Controladors;

   import Entitats.Soci.Soci;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.UsuariActual.UsuariActual;
   import Entitats.PropostaModificacioSoci.PropostaModificacioSoci;
   import Entitats.PropostaModificacioSoci.RelacioPropostesModificacioSoci;
   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder crear una nova proposta de modificacio
*@author Jordi Moles i Blanco, Maig 2005
*/

   public class ControlAltaPropostaModificacioSoci
   {
   
   /**
   * Constructor de la classe. 
   */
      public ControlAltaPropostaModificacioSoci()
      {
      
      
      }
   
   /**
   * Destructor de la classe
   */
      public void destructorControlAltaPropostaModificacioSoci()
      {
      
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public boolean iniciaPropostaAltaModificacioSoci(UsuariActual usuariActual,ObjectePersistencia objectePersistencia)
      {
      
         if(usuariActual.nivellActual()!=3 & usuariActual.nivellActual()!=1)
         {
         
            PropostaModificacioSoci pms = new PropostaModificacioSoci();
         
            while(objectePersistencia.hiHaCamps())
            {
            
               if(objectePersistencia.obteCamp().compareToIgnoreCase("nom")==0) pms.estableixNom(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("cognom1")==0) pms.estableixCognom1(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("cognom2")==0) pms.estableixCognom2(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("identificadorPersonal")==0) pms.estableixIdentificadorPersonal(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("adresa")==0) pms.estableixAdresa(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("telefon")==0) pms.estableixTelefon(Integer.parseInt(objectePersistencia.obteValor()));
               if(objectePersistencia.obteCamp().compareToIgnoreCase("dataNaixement")==0) pms.estableixDataNaixement(objectePersistencia.obteValor());
               if(objectePersistencia.obteCamp().compareToIgnoreCase("numSoci")==0) pms.estableixNumSoci(Integer.parseInt(objectePersistencia.obteValor()));
            
               objectePersistencia.seguent();
            
            }
         
            RelacioPropostesModificacioSoci.afegirPropostaModificacioSoci(pms);
         
            return true;
         
         }
         
         else
         {
         
            File docFile = new File(".././GUI/SGEC_GUI_usuariSecretari.jar");
            String nomFitxer = docFile.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla = new AbaRenderer(nomFitxer, false, null);
               pantalla.load();
               pantalla.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
               acceptar=(JButton)(pantalla.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("usuariSecretari"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
               
                  System.err.println("(ControlAltaPropostaModificacioSoci1)Error: " + e.getMessage());
               
               }
         
            docFile = null;
         
            return false;
         
         }
      
      }
   
   }