   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Actuacio.Actuacio;
   import Entitats.Actuacio.RelacioActuacions;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder eliminar una actuacio del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/

   public class ControlBaixaActuacio
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean baixaSenseProblemes;
      String dataActuacio,poblacioActuacio,llocActuacio,horaActuacio;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre eliminar actuacions del sistema. 
   */
      public ControlBaixaActuacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_baixaActuacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlBaixaActuacio()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaBaixaActuacio()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(baixaSenseProblemes && campsBuits<4)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("baixaActuacio"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatActuacio.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             Actuacio actuacio = new Actuacio();
                                             JSSComboBox llistat;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(dataActuacio.compareToIgnoreCase("")!=0)op.afegirCampData("dataActuacio",dataActuacio);
                                                if(poblacioActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("poblacio",poblacioActuacio);
                                                if(llocActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("lloc",llocActuacio);
                                                if(horaActuacio.compareToIgnoreCase("")!=0)op.afegirCampHoraSenseSegons("horaInici",horaActuacio);
                                             
                                                RelacioActuacions relacioActuacions = new RelacioActuacions();
                                                relacioActuacions.obteActuacioPerMultiplesCamps(op);
                                             
                                                while(relacioActuacions.hiHaActuacions())
                                                {
                                                
                                                   actuacio=relacioActuacions.obteActuacio();
                                                
                                                   llistat.addItem(actuacio.obteLloc()+" , "+actuacio.obteData(),actuacio.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                   JButton acceptar,cancelar;
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 confirmaEliminacio(seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                
                                                }
                                                else
                                                {
                                                
                                                   JButton acceptar;
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioActuacions.destructorRelacioActuacions();
                                                actuacio.destructorActuacio();
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlBaixaActuacio1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("baixaActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaActuacio2)Error: " + e.getMessage());
            
            }
      
      }
   
      private void capturaIValidaDades()
      {
      
         baixaSenseProblemes = true;
         campsBuits=0;
      
         JTextField data,poblacio,lloc,hora;
      
         data=(JTextField)(pantalla.getObject("valorData"));
         dataActuacio=((JTextField)(pantalla.getObject("valorData"))).getText();
         poblacio=(JTextField)(pantalla.getObject("valorPoblacio"));
         poblacioActuacio=((JTextField)(pantalla.getObject("valorPoblacio"))).getText();
         lloc=(JTextField)(pantalla.getObject("valorLloc"));
         llocActuacio=((JTextField)(pantalla.getObject("valorLloc"))).getText();
         hora=(JTextField)(pantalla.getObject("valorHora"));
         horaActuacio=((JTextField)(pantalla.getObject("valorHora"))).getText();
      
         if(dataActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(poblacioActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(llocActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(horaActuacio.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(data.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataActuacio)) baixaSenseProblemes=false;
         else
         {
         
            if(poblacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(poblacioActuacio)) baixaSenseProblemes=false;
            else
            {
            
               if(lloc.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(llocActuacio)) baixaSenseProblemes=false;
               else
               {
               
                  if(hora.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaHora(horaActuacio)) baixaSenseProblemes=false;
               
               }
            
            }
         
         }
      
         if(baixaSenseProblemes==false | campsBuits==4)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlBaixaActuacio3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void confirmaEliminacio(final long identificadorActuacio)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_confirmacioBaixaActuacio.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,cancelar;
         JTextField camp;
         JTextArea camp2;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Actuacio Actuacio = RelacioActuacions.obteActuacioPerIdentificadorActuacio((int)identificadorActuacio);
         
            camp=(JTextField)(pantalla3.getObject("valorData"));
            camp.setText(Actuacio.obteData());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorPoblacio"));
            camp.setText(Actuacio.obtePoblacio());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorLloc"));
            camp.setText(Actuacio.obteLloc());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorHora"));
            camp.setText(Actuacio.obteHoraInici());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorObservacions"));
            camp2.setText(Actuacio.obteObservacions());
            camp2.setEnabled(false);
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaActuacio"))).dispose();
                                          RelacioActuacions.eliminaActuacioPerIdentificadorActuacio((int)identificadorActuacio);
                                       
                                          File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                          String nomFitxer5 = docFile5.getAbsolutePath();
                                          JButton acceptar;
                                       
                                          try
                                          {
                                          
                                             final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                             pantalla5.load();
                                             pantalla5.renderInterface();
                                          
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
                                             acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                          
                                             acceptar.addActionListener(
                                                                  
                                                                     new ActionListener()                 
                                                                     {
                                                                     
                                                                        public void actionPerformed(ActionEvent ae)       
                                                                        {
                                                                        
                                                                           ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                        
                                                                        }
                                                                     
                                                                     });
                                          
                                          }
                                          
                                             catch(Exception e) {        
                                             
                                                System.err.println("(ControlBaixaActuacio4)Error: " + e.getMessage());
                                             
                                             }
                                       
                                          docFile5 = null;
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO CANCEL.LAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            cancelar=(JButton)(pantalla3.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaActuacio5)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }