   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder eliminar una pesa del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlBaixaPesa
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean baixaSenseProblemes;
      String nomPesa,duradaPesa,procedenciaPesa,autorPesa,dataCreacioPesa,descripcioPesa;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre eliminar peces del sistema. 
   */
      public ControlBaixaPesa()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_baixaPesa.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlBaixaPesa()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaBaixaPesa()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(baixaSenseProblemes && campsBuits<5)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("baixaPesa"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatPesa.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             String nomICognoms="";
                                             Pesa pesa = new Pesa();
                                             JSSComboBox llistat;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomPesa.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomPesa);
                                                if(duradaPesa.compareToIgnoreCase("")!=0)op.afegirCampHora("durada",duradaPesa);
                                                if(procedenciaPesa.compareToIgnoreCase("")!=0)op.afegirCampText("procedencia",procedenciaPesa);
                                                if(autorPesa.compareToIgnoreCase("")!=0)op.afegirCampText("autor",autorPesa);
                                                if(dataCreacioPesa.compareToIgnoreCase("")!=0)op.afegirCampData("dataCreacio",dataCreacioPesa);
                                             
                                                RelacioPeces relacioPeces = new RelacioPeces();
                                                relacioPeces.obtePesaPerMultiplesCamps(op);
                                             
                                                while(relacioPeces.hiHaPeces())
                                                {
                                                
                                                   pesa=relacioPeces.obtePesa();
                                                
                                                   llistat.addItem(pesa.obteNom(),pesa.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                   JButton acceptar,cancelar;
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 confirmaEliminacio(seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   JButton acceptar;
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioPeces.destructorRelacioPeces();
                                                pesa.destructorPesa();
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlBaixaPesa1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("baixaPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaPesa2)Error: " + e.getMessage());
            
            }
      
      }
   
      private void capturaIValidaDades()
      {
      
         baixaSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,durada,procedencia,autor,dataCreacio;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomPesa=((JTextField)(pantalla.getObject("valorNom"))).getText();
         durada=(JTextField)(pantalla.getObject("valorDurada"));
         duradaPesa=((JTextField)(pantalla.getObject("valorDurada"))).getText();
         procedencia=(JTextField)(pantalla.getObject("valorProcedencia"));
         procedenciaPesa=((JTextField)(pantalla.getObject("valorProcedencia"))).getText();
         autor=(JTextField)(pantalla.getObject("valorAutor"));
         autorPesa=((JTextField)(pantalla.getObject("valorAutor"))).getText();
         dataCreacio=(JTextField)(pantalla.getObject("valorDataCreacio"));
         dataCreacioPesa=((JTextField)(pantalla.getObject("valorDataCreacio"))).getText();
      
         if(nomPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(duradaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(procedenciaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(autorPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(dataCreacioPesa.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomPesa)) baixaSenseProblemes=false;
         else
         {
         
            if(durada.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDurada(duradaPesa)) baixaSenseProblemes=false;
            else
            {
            
               if(procedencia.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(procedenciaPesa)) baixaSenseProblemes=false;
               else
               {
               
                  if(autor.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(autorPesa)) baixaSenseProblemes=false;
                  else
                  {
                  
                     if(dataCreacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataCreacioPesa)) baixaSenseProblemes=false;
                  
                  }
               
               }
            
            }
         
         }
      
         if(baixaSenseProblemes==false | campsBuits==5)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlBaixaPesa3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void confirmaEliminacio(final long identificadorPesa)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_confirmacioBaixaPesa.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,cancelar;
         JTextField camp;
         JTextArea camp2;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Pesa Pesa = RelacioPeces.obtePesaPerIdentificadorPesa((int)identificadorPesa);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Pesa.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDurada"));
            camp.setText(Pesa.obteDurada());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorProcedencia"));
            camp.setText(Pesa.obteProcedencia());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAutor"));
            camp.setText(Pesa.obteAutor());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataCreacio"));
            camp.setText(Pesa.obteDataCreacio());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorDescripcio"));
            camp2.setText(Pesa.obteDescripcio());
            camp2.setEnabled(false);
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaPesa"))).dispose();
                                          RelacioPeces.eliminaPesaPerIdentificadorPesa((int)identificadorPesa);
                                       
                                          File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                          String nomFitxer5 = docFile5.getAbsolutePath();
                                          JButton acceptar;
                                       
                                          try
                                          {
                                          
                                             final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                             pantalla5.load();
                                             pantalla5.renderInterface();
                                          
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                             acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                          
                                             acceptar.addActionListener(
                                                                  
                                                                  
                                                                  
                                                                     new ActionListener()                 
                                                                     
                                                                     
                                                                     {
                                                                     
                                                                     
                                                                     
                                                                        public void actionPerformed(ActionEvent ae)       
                                                                        
                                                                        
                                                                        {
                                                                        
                                                                           ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                        
                                                                        }
                                                                     
                                                                     });
                                          
                                          }
                                          
                                          
                                          
                                             catch(Exception e) {        
                                             
                                             
                                             
                                                System.err.println("(ControlBaixaPesa4)Error: " + e.getMessage());
                                             
                                             }
                                       
                                          docFile5 = null;
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO CANCEL.LAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            cancelar=(JButton)(pantalla3.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaPesa5)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }