   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder eliminar un soci del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlBaixaSoci
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean baixaSenseProblemes;
      String nomSoci,cognom1Soci,cognom2Soci,identificadorPersonalSoci,adresaSoci;
      String telefonSoci,dataNaixementSoci,numSoci;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre eliminar socis del sistema. 
   */
      public ControlBaixaSoci()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_baixaSoci.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlBaixaSoci()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaBaixaSoci()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(baixaSenseProblemes && campsBuits<8)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("baixaSoci"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatSoci.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             String nomICognoms="";
                                             Soci soci = new Soci();
                                             JSSComboBox llistat;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomSoci.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomSoci);
                                                if(cognom1Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom1",cognom1Soci);
                                                if(cognom2Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom2",cognom2Soci);
                                                if(identificadorPersonalSoci.compareToIgnoreCase("")!=0)op.afegirCampText("identificadorPersonal",identificadorPersonalSoci);
                                                if(adresaSoci.compareToIgnoreCase("")!=0)op.afegirCampText("adresa",adresaSoci);
                                                if(telefonSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("telefon",Integer.parseInt(telefonSoci));
                                                if(dataNaixementSoci.compareToIgnoreCase("")!=0)op.afegirCampData("dataNaixement",dataNaixementSoci);
                                                if(numSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("numSoci",Integer.parseInt(numSoci));
                                             
                                                RelacioSocis relacioSocis = new RelacioSocis();
                                                relacioSocis.obteSociPerMultiplesCamps(op);
                                             
                                                while(relacioSocis.hiHaSocis())
                                                {
                                                
                                                   nomICognoms="";
                                                   soci=relacioSocis.obteSoci();
                                                   if(soci.esActiu())
                                                   {
                                                      nomICognoms+=soci.obteCognom1()+" "+soci.obteCognom2()+" , "+soci.obteNom();
                                                      llistat.addItem(nomICognoms,soci.obteNumSoci());
                                                      elementsTrobats++;
                                                   }
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                   JButton acceptar,cancelar;
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 confirmaEliminacio(seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   JButton acceptar;
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioSocis.destructorRelacioSocis();
                                                soci.destructorSoci();
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlBaixaSoci1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("baixaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaSoci2)Error: " + e.getMessage());
            
            }
      
      }
   
      private void capturaIValidaDades()
      
      {
      
         baixaSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,num;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomSoci=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1=(JTextField)(pantalla.getObject("valorCognom1"));
         cognom1Soci=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2=(JTextField)(pantalla.getObject("valorCognom2"));
         cognom2Soci=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonal=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
         identificadorPersonalSoci=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresa=(JTextField)(pantalla.getObject("valorAdresa"));
         adresaSoci=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefon=(JTextField)(pantalla.getObject("valorTelefon"));
         telefonSoci=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixement=(JTextField)(pantalla.getObject("valorDataNaixement"));
         dataNaixementSoci=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
         num=(JTextField)(pantalla.getObject("valorNumSoci"));
         numSoci=((JTextField)(pantalla.getObject("valorNumSoci"))).getText();
      
         if(nomSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom1Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom2Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(identificadorPersonalSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(adresaSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(telefonSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(dataNaixementSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(numSoci.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomSoci)) baixaSenseProblemes=false;
         else
         {
         
            if(cognom1.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1Soci)) baixaSenseProblemes=false;
            else
            {
            
               if(cognom2.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2Soci)) baixaSenseProblemes=false;
               else
               {
               
                  if(identificadorPersonal.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSoci)) baixaSenseProblemes=false;
                  else
                  {
                  
                     if(adresa.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaSoci)) baixaSenseProblemes=false;
                     else
                     {
                     
                        if(telefon.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonSoci)) baixaSenseProblemes=false;
                        else
                        {
                        
                           if(dataNaixement.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementSoci)) baixaSenseProblemes=false;
                           else
                           {
                           
                              if(num.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaXifra(numSoci)) baixaSenseProblemes=false;
                           
                           }
                        }
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(baixaSenseProblemes==false | campsBuits==8)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlBaixaSoci3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void confirmaEliminacio(final long numSoci)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_confirmacioBaixaSoci.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,cancelar;
         JTextField camp;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Soci Soci = RelacioSocis.obteSociPerNumSoci((int)numSoci);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Soci.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom1"));
            camp.setText(Soci.obteCognom1());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom2"));
            camp.setText(Soci.obteCognom2());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorIdentificadorPersonal"));
            camp.setText(Soci.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAdresa"));
            camp.setText(Soci.obteAdresa());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorTelefon"));
            camp.setText(""+Soci.obteTelefon()+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataNaixement"));
            camp.setText(Soci.obteDataNaixement());
            camp.setEnabled(false);
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          boolean eliminaParticipantOK = true; 
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaSoci"))).dispose();
                                          if(RelacioParticipants.Existeix((int)numSoci)==1) eliminaParticipantOK = RelacioParticipants.eliminaParticipantPerNumSoci((int)numSoci);
                                          if(eliminaParticipantOK & RelacioSocis.eliminaSociPerNumSoci((int)numSoci))
                                          {
                                          
                                             File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                             String nomFitxer5 = docFile5.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                pantalla5.load();
                                                pantalla5.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
                                                acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                     
                                                                        new ActionListener()                 
                                                                        
                                                                        {
                                                                        
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)       
                                                                           
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {        
                                                
                                                
                                                   System.err.println("(ControlBaixaSoci4)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile5 = null;
                                          }
                                       }
                                    
                                    });
         
               ///////////BOTO CANCEL.LAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
            cancelar=(JButton)(pantalla3.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("confirmacioBaixaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlBaixaSoci5)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }