   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.awt.Toolkit;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Pesa.Pesa;
   import Entitats.Participant.Participant;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Actuacio.Actuacio;
   import Entitats.Actuacio.RelacioActuacions;
   import Entitats.Actuacio.RelacioImatgesActuacio;
   import java.util.Vector;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import java.net.URL; 
   import Entitats.Eines.Navegador;
   import Entitats.Eines.EscriuFitxerImatges;
   import java.sql.Timestamp;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder consultar la info d'una actuacio del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlConsultaActuacio
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean consultaSenseProblemes;
      String dataActuacio,poblacioActuacio,llocActuacio,horaActuacio;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre consultar informacio sobre actuacions. 
   */
      public ControlConsultaActuacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_consultaActuacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlConsultaActuacio()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaConsultaActuacio()
      
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(consultaSenseProblemes && campsBuits<4)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("consultaActuacio"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatActuacio.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             Actuacio actuacio = new Actuacio();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(dataActuacio.compareToIgnoreCase("")!=0)op.afegirCampData("dataActuacio",dataActuacio);
                                                if(poblacioActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("poblacio",poblacioActuacio);
                                                if(llocActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("lloc",llocActuacio);
                                                if(horaActuacio.compareToIgnoreCase("")!=0)op.afegirCampHoraSenseSegons("horaInici",horaActuacio);
                                             
                                                RelacioActuacions relacioActuacions = new RelacioActuacions();
                                                relacioActuacions.obteActuacioPerMultiplesCamps(op);
                                             
                                                while(relacioActuacions.hiHaActuacions())
                                                {
                                                
                                                   actuacio=relacioActuacions.obteActuacio();
                                                
                                                   llistat.addItem(actuacio.obteLloc()+" , "+actuacio.obteData(),actuacio.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 mostraActuacio((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioActuacions.destructorRelacioActuacions();
                                                actuacio.destructorActuacio();
                                             
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                
                                                   System.err.println("(ControlConsultaActuacio1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("consultaActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlConsultaActuacio2)Error: " + e.getMessage());
            
            }
      
      }
   
   
      private void capturaIValidaDades()
      {
      
         consultaSenseProblemes = true;
         campsBuits=0;
      
         JTextField data,poblacio,lloc,hora;
      
         data=(JTextField)(pantalla.getObject("valorData"));
         dataActuacio=((JTextField)(pantalla.getObject("valorData"))).getText();
         poblacio=(JTextField)(pantalla.getObject("valorPoblacio"));
         poblacioActuacio=((JTextField)(pantalla.getObject("valorPoblacio"))).getText();
         lloc=(JTextField)(pantalla.getObject("valorLloc"));
         llocActuacio=((JTextField)(pantalla.getObject("valorLloc"))).getText();
         hora=(JTextField)(pantalla.getObject("valorHora"));
         horaActuacio=((JTextField)(pantalla.getObject("valorHora"))).getText();
      
         if(dataActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(poblacioActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(llocActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(horaActuacio.compareToIgnoreCase("")==0) campsBuits++;
      
      	   //validar dades
      
         if(data.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataActuacio)) consultaSenseProblemes=false;
         else
         {
         
            if(poblacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(poblacioActuacio)) consultaSenseProblemes=false;
            else
            {
            
               if(lloc.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(llocActuacio)) consultaSenseProblemes=false;
               else
               {
               
                  if(hora.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaHora(horaActuacio)) consultaSenseProblemes=false;
               
               }
            
            }
         
         }
      
         if(consultaSenseProblemes==false | campsBuits==4)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlConsultaActuacio3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void mostraActuacio(final int identificadorActuacio)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_resultatConsultaActuacio.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar,obrir;
         JTextField camp;
         JTextArea camp2;
         JList pecesActuacio,participantsActuacio;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            //URL url = getClass().getResource("prova.jpg");
            //((JButton)(pantalla3.getObject("acceptar"))).setIcon(new ImageIcon(url));
         
            final Actuacio Actuacio = RelacioActuacions.obteActuacioPerIdentificadorActuacio(identificadorActuacio);
         
            camp=(JTextField)(pantalla3.getObject("valorData"));
            camp.setText(Actuacio.obteData());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorPoblacio"));
            camp.setText(Actuacio.obtePoblacio());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorLloc"));
            camp.setText(Actuacio.obteLloc());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorHora"));
            camp.setText(Actuacio.obteHoraInici());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorObservacions"));
            camp2.setText(Actuacio.obteObservacions());
            camp2.setEnabled(false);
         
            pecesActuacio = (JList)(pantalla3.getObject("pecesActuacio"));
            participantsActuacio = (JList)(pantalla3.getObject("participantsActuacio"));
         
            Vector elementsLlistat = new Vector();
            Vector elementsLlistat2 = new Vector();
         
            Actuacio.obtePeces();
         
            while(Actuacio.hiHaPeces())
            {
            
               elementsLlistat.add(RelacioPeces.obtePesaPerIdentificadorPesa(Actuacio.obtePesa()).obteNom());
            
            }
         
            pecesActuacio.setListData(elementsLlistat);
         
            Actuacio.obteParticipants();
            Participant part; 
         
            while(Actuacio.hiHaParticipants())
            {
            
               part = RelacioParticipants.obteParticipantPerNumSoci(Actuacio.obteParticipant());
               elementsLlistat2.add(part.obteCognom1()+" "+part.obteCognom2()+" ,"+part.obteNom());
            
            }
         
            participantsActuacio.setListData(elementsLlistat2);
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("resultatConsultaActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
            obrir=(JButton)(pantalla3.getObject("obrir"));
         
            obrir.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                       //hem d'afegir que escrigui el fitxer imatges.dat
                                          try
                                          {
                                             RelacioImatgesActuacio rel = new RelacioImatgesActuacio();
                                             rel.obteImatgesActuacio(Actuacio.obteIdentificador());
                                          
                                             Timestamp time = new Timestamp(System.currentTimeMillis());
                                          
                                          //assignem un nom al fitxer
                                             String nouFitxer = ""+(time.getTime()+time.getTime());
                                          
                                             EscriuFitxerImatges.EscriuFitxerActuacions(rel,nouFitxer);
                                          
                                             Navegador.obreURL("../Actuacio/"+nouFitxer+".htm");
                                          
                                          }
                                             catch(Exception e)
                                             {
                                                System.err.println("(ControlConsultaActuacio4)Error: )"+e.getMessage());
                                             }
                                       }
                                    
                                    });									
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlConsultaActuacio5)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   
   }