
   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.io.FileOutputStream;
   import java.io.DataOutputStream;
   import java.io.FileInputStream;
   import java.io.DataInputStream;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder visualitzar les dades
* de conexi a la bbdd i tamb modificarles.
*@author Jordi Moles i Blanco, Maig 2006
*/

   public class ControlDadesBBDD
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
   
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre la gestio de les dades de la bbdd. 
   */
      public ControlDadesBBDD()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_dadesbbdd.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlDadesBBDD()
      {
      
         pantalla=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaControlBBDD()
      {
      
         JButton acceptar,cancelar;
         JTextField camp;
      
         DataInputStream dis;
         String linia,login,pas,ip,port;
      
         linia = login = pas = ip = port = "";
      
         try
         {
         
            dis = new DataInputStream(new FileInputStream("../Persistencia/config.dat"));
         
         
            while(null != (linia=dis.readLine()))
            {
               linia = linia.trim(); 
               if(linia.substring(0,5).compareTo("login")==0) login = linia.substring(6);
               else
               {
                  if(linia.substring(0,3).compareTo("pas")==0) pas = linia.substring(4);
                  else
                  {
                     if(linia.substring(0,4).compareTo("port")==0) port = linia.substring(5);
                     else
                     {
                        if(linia.substring(0,2).compareTo("ip")==0) ip = linia.substring(3);
                     }
                  }
               }
            
            }
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            camp=(JTextField)(pantalla.getObject("login"));
            camp.setText(login);
            camp=(JTextField)(pantalla.getObject("pas"));
            camp.setText(pas);
            camp=(JTextField)(pantalla.getObject("ip"));
            camp.setText(ip);
            camp=(JTextField)(pantalla.getObject("port"));
            camp.setText(port);
         
            	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          try
                                          {
                                          
                                             File fi = new File("../Persistencia/config.dat");
                                             fi.delete();
                                          
                                             DataOutputStream dos = new DataOutputStream(new FileOutputStream("../Persistencia/config.dat"));
                                          
                                             JTextField nouvalor;
                                          
                                             nouvalor = (JTextField)(pantalla.getObject("login"));
                                             dos.writeBytes("login="+nouvalor.getText()+"\n");
                                             nouvalor = (JTextField)(pantalla.getObject("pas"));
                                             dos.writeBytes("pas="+nouvalor.getText()+"\n");
                                             nouvalor = (JTextField)(pantalla.getObject("ip"));
                                             dos.writeBytes("ip="+nouvalor.getText()+"\n");
                                             nouvalor = (JTextField)(pantalla.getObject("port"));
                                             dos.writeBytes("port="+nouvalor.getText()+"\n");
                                          
                                             dos.close();
                                          
                                             ((JFrame)(pantalla.getObject("dades"))).dispose();
                                          
                                          }
                                             catch(Exception e) {        
                                             
                                                System.err.println("(ControlDadesBBDD1)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });
         
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("dades"))).dispose();
                                       }
                                    
                                    });
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlDadesBBDD2)Error: " + e.getMessage());
            
            } 
      
      }
   
   
   }