   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.Eines.Navegador;
   import Entitats.Soci.RelacioImatgesSoci;
   import Entitats.Actuacio.RelacioImatgesActuacio;
   import Entitats.Pesa.RelacioImatgesPesa;
   import Entitats.Eines.EscriuFitxerImatges;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder visualitzar les imatges
* dels albums de fotos aixi com tambe afegir noves imatges o eliminar-ne.
*@author Jordi Moles i Blanco, Maig 2006
*/

   public class ControlGaleria
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
   
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre la gestio de la galeria d'imatges. 
   */
      public ControlGaleria()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_galeriaImatges.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlGaleria()
      {
      
         pantalla=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaGaleria()
      {
      
         JButton socis,actuacions,repertori,sortir;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO SOCIS\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            socis=(JButton)(pantalla.getObject("socis"));
         
            socis.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          RelacioImatgesSoci rel = new RelacioImatgesSoci();
                                          rel.obteImatgesSocis();
                                          EscriuFitxerImatges.EscriuFitxerTotsSocis(rel);
                                       
                                          Navegador.obreURL("../Galeria/socis/socis.htm");
                                       
                                       }
                                    
                                    });
         
         
         									///////////BOTO Repertori\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            repertori=(JButton)(pantalla.getObject("repertori"));
         
            repertori.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          RelacioImatgesPesa rel = new RelacioImatgesPesa();
                                          rel.obteImatgesPeces();
                                          EscriuFitxerImatges.EscriuFitxerTotesPeces(rel);
                                       
                                          Navegador.obreURL("../Galeria/peces/repertori.htm");
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO Actuacions\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            actuacions=(JButton)(pantalla.getObject("actuacions"));
         
            actuacions.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          RelacioImatgesActuacio rel = new RelacioImatgesActuacio();
                                          rel.obteImatgesActuacions();
                                          EscriuFitxerImatges.EscriuFitxerTotesActuacions(rel);
                                       
                                          Navegador.obreURL("../Galeria/actuacions/actuacions.htm");
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO Sortir\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            sortir=(JButton)(pantalla.getObject("sortir"));
         
            sortir.addActionListener(
                                 
                                 
                                 
                                    new ActionListener()
                                    
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("galeriaimatges"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlGaleria1)Error: " + e.getMessage());
            
            } 
      
      }
   
   
   }