   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.UsuariAplicacio.RegistreConnexions;
   import Entitats.Persistencia.ObjectePersistencia;
   import java.util.Vector;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder consultar qui ha utilitzat 
* l'aplicacio per accedir al sistema.
*@author Jordi Moles i Blanco, Abril 2006
*/
   public class ControlGestioRegistresConnexio
   {
   
      private File docFile;
      private String nomFitxer;
      private AbaRenderer pantalla;
      private JList llista;
      private Vector elementsLlista;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre consultar la informacio de usuaris que han accedit al sistema. 
   */
      public ControlGestioRegistresConnexio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_registreConnexions.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
         elementsLlista = new Vector();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlRegistresConnexio()
      {
      
         pantalla=null;
         elementsLlista.removeAllElements();
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaGestioRegistresConnexio()
      {
      
         JButton sortir,tots,ultimsDeu,ultimsCent;
         final ObjectePersistencia campsAOrdenar = new ObjectePersistencia();
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            llista=(JList)(pantalla.getObject("llista"));
         
         	///////////BOTO SORTIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            sortir=(JButton)(pantalla.getObject("sortir"));
         
            sortir.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("registreConnexions"))).dispose();
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO TOTS\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            tots=(JButton)(pantalla.getObject("tots"));
         
            tots.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          campsAOrdenar.afegirCampText("dataConnexio","");
                                          campsAOrdenar.afegirCampText("horaConnexio","");
                                       
                                          RegistreConnexions registreConnexions = new RegistreConnexions();
                                          registreConnexions.obteTotesLesConnexionsOrdenatsDescendentment(campsAOrdenar);
                                       
                                          elementsLlista.removeAllElements();
                                       
                                          while(registreConnexions.hiHaConnexions())
                                          {
                                          
                                             elementsLlista.add(registreConnexions.obteRegistreConnexio());
                                          
                                          }
                                       
                                          registreConnexions.destructorRegistreConnexions();
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO ULTIMSDEU\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            ultimsDeu=(JButton)(pantalla.getObject("ultimsDeu"));
         
            ultimsDeu.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          campsAOrdenar.afegirCampText("dataConnexio","");
                                          campsAOrdenar.afegirCampText("horaConnexio","");
                                       
                                          RegistreConnexions registreConnexions = new RegistreConnexions();
                                          registreConnexions.obteTotesLesConnexionsOrdenatsDescendentment(campsAOrdenar);
                                       
                                          int nElements=0;
                                          elementsLlista.removeAllElements();
                                       
                                          while(nElements<10 && registreConnexions.hiHaConnexions())
                                          {
                                          
                                             elementsLlista.add(registreConnexions.obteRegistreConnexio());
                                             nElements++;
                                          
                                          }
                                       
                                          registreConnexions.destructorRegistreConnexions();
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO ULTIMSCENT\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            ultimsCent=(JButton)(pantalla.getObject("ultimsCent"));
         
            ultimsCent.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          campsAOrdenar.afegirCampText("dataConnexio","");
                                          campsAOrdenar.afegirCampText("horaConnexio","");
                                       
                                          RegistreConnexions registreConnexions = new RegistreConnexions();
                                          registreConnexions.obteTotesLesConnexionsOrdenatsDescendentment(campsAOrdenar);
                                       
                                          int nElements=0;
                                          elementsLlista.removeAllElements();
                                       
                                          while(nElements<100 && registreConnexions.hiHaConnexions())
                                          {
                                          
                                             elementsLlista.add(registreConnexions.obteRegistreConnexio());
                                             nElements++;
                                          
                                          }
                                       
                                          registreConnexions.destructorRegistreConnexions();
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlGestioRegistresConnexio1)Error: " + e.getMessage());
            
            } 
      }
   
   }