   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Pesa.RelacioImatgesPesa;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Eines.ImageFileView;
   import Entitats.Eines.ImageFilter;
   import Entitats.Eines.ImagePreview;
   import Entitats.Eines.Utils;
   import Entitats.Eines.CopiaFitxer;
   import Entitats.Eines.Fitxer;
   import Entitats.Eines.Cadena;
   import java.sql.Timestamp;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;


/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder modificar la informacio
* d'una pesa.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlModificacioPesa
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean modificacioSenseProblemes;
      String nomPesa,duradaPesa,procedenciaPesa,autorPesa,dataCreacioPesa,descripcioPesa;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari modificar una pesa. 
   */
      public ControlModificacioPesa()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_modificacioPesa.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlModificacioPesa()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaModificacioPesa()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(modificacioSenseProblemes && campsBuits<5)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("modificacioPesa"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatPesa.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             Pesa pesa = new Pesa();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomPesa.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomPesa);
                                                if(duradaPesa.compareToIgnoreCase("")!=0)op.afegirCampHora("durada",duradaPesa);
                                                if(procedenciaPesa.compareToIgnoreCase("")!=0)op.afegirCampText("procedencia",procedenciaPesa);
                                                if(autorPesa.compareToIgnoreCase("")!=0)op.afegirCampText("autor",autorPesa);
                                                if(dataCreacioPesa.compareToIgnoreCase("")!=0)op.afegirCampData("dataCreacio",dataCreacioPesa);
                                             
                                                RelacioPeces relacioPeces = new RelacioPeces();
                                                relacioPeces.obtePesaPerMultiplesCamps(op);
                                             
                                                while(relacioPeces.hiHaPeces())
                                                {
                                                
                                                   pesa=relacioPeces.obtePesa();
                                                
                                                   llistat.addItem(pesa.obteNom(),pesa.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 modificaPesa((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioPeces.destructorRelacioPeces();
                                                pesa.destructorPesa();
                                             
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlModificacioPesa1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("modificacioPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlModificacioPesa2)Error: " + e.getMessage());
            
            }
      
      }
   
   
   
      private void capturaIValidaDades()
      
      {
      
         modificacioSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,durada,procedencia,autor,dataCreacio;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomPesa=((JTextField)(pantalla.getObject("valorNom"))).getText();
         durada=(JTextField)(pantalla.getObject("valorDurada"));
         duradaPesa=((JTextField)(pantalla.getObject("valorDurada"))).getText();
         procedencia=(JTextField)(pantalla.getObject("valorProcedencia"));
         procedenciaPesa=((JTextField)(pantalla.getObject("valorProcedencia"))).getText();
         autor=(JTextField)(pantalla.getObject("valorAutor"));
         autorPesa=((JTextField)(pantalla.getObject("valorAutor"))).getText();
         dataCreacio=(JTextField)(pantalla.getObject("valorDataCreacio"));
         dataCreacioPesa=((JTextField)(pantalla.getObject("valorDataCreacio"))).getText();
      
         if(nomPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(duradaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(procedenciaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(autorPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(dataCreacioPesa.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomPesa)) modificacioSenseProblemes=false;
         else
         {
         
            if(durada.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDurada(duradaPesa)) modificacioSenseProblemes=false;
            else
            {
            
               if(procedencia.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(procedenciaPesa)) modificacioSenseProblemes=false;
               else
               {
               
                  if(autor.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(autorPesa)) modificacioSenseProblemes=false;
                  else
                  {
                  
                     if(dataCreacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataCreacioPesa)) modificacioSenseProblemes=false;
                  
                  }
               
               }
            
            }
         
         }
      
         if(modificacioSenseProblemes==false | campsBuits==5)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlModificacioPesa3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
   
      private void modificaPesa(final int identificadorPesa)
      
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_novesDadesModificacioPesa.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar,obrir,assignar;
         JTextField camp;
         JTextArea camp2;
      
         final Fitxer arxiu = new Fitxer();
         final Fitxer directoriDesti = new Fitxer();
         final Fitxer fitxerDesti = new Fitxer();
         final Cadena rutaNovaImatge = new Cadena();
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Pesa Pesa = RelacioPeces.obtePesaPerIdentificadorPesa(identificadorPesa);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Pesa.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDurada"));
            camp.setText(Pesa.obteDurada());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorProcedencia"));
            camp.setText(Pesa.obteProcedencia());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAutor"));
            camp.setText(Pesa.obteAutor());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataCreacio"));
            camp.setText(Pesa.obteDataCreacio());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorDescripcio"));
            camp2.setText(Pesa.obteDescripcio());
            camp2.setEnabled(false);
         
            RelacioImatgesPesa rel = new RelacioImatgesPesa();
            rel.obteImatgesPesa(Pesa.obteIdentificador());
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
            rel.destructorRelacioImatgesPesa();
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("novesDadesModificacioPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            obrir=(JButton)(pantalla3.getObject("obrir"));
         
            obrir.addActionListener(                                                   
                                 
                                    new ActionListener()                                                
                                    
                                    {                                  
                                       public void actionPerformed(ActionEvent ae)                                         
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                             JFileChooser fc;
                                             fc = new JFileChooser();
                                          
                                             fc.addChoosableFileFilter(new ImageFilter());
                                             fc.setAcceptAllFileFilterUsed(false);
                                          
                                             fc.setFileView(new ImageFileView());
                                          
                                             fc.setAccessory(new ImagePreview(fc));
                                          
                                          
                                             int returnVal = fc.showDialog((JFrame)(pantalla3.getObject("novesDadesModificacioPesa")),"Afegir");
                                          
                                             if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File directori = fc.getCurrentDirectory();
                                                arxiu.estableixFitxer(fc.getSelectedFile());
                                                String fitxer = arxiu.obteFitxer().getName();
                                                ((JTextField)(pantalla3.getObject("nomImatge"))).setText(fitxer);
                                             
                                                directoriDesti.estableixFitxer(new File("../Galeria/peces/imatges/"));
                                             
                                                Timestamp time = new Timestamp(System.currentTimeMillis());
                                                String nouFitxer = (time.getTime()+time.getTime())+"--"+fitxer;
                                             
                                                fitxerDesti.estableixFitxer(new File(directoriDesti.obteFitxer(), nouFitxer));
                                             
                                                rutaNovaImatge.estableixCadena("../Galeria/peces/imatges/"+nouFitxer);
                                             
                                             } 
                                          
                                             fc.setSelectedFile(null);
                                          
                                          }
                                          
                                             catch(Exception e) {        
                                             
                                                System.err.println("(ControlModificacioPesa4)Error: " + e.getMessage());
                                             
                                             }
                                       
                                       }
                                    
                                    });		
         
              ///////////BOTO ASSIGNAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
            assignar=(JButton)(pantalla3.getObject("assignar"));
         
            assignar.addActionListener(
                                 
                                    new ActionListener()    
                                    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                             if(arxiu.obteFitxer()!=null)
                                             {
                                                Long checksumSrc = CopiaFitxer.copia(arxiu.obteFitxer(), fitxerDesti.obteFitxer());
                                             
                                                Long checksumDest = CopiaFitxer.creaChecksum(fitxerDesti.obteFitxer());
                                                if (!checksumSrc.equals(checksumDest)) {
                                                   System.err.println("(ControlModificacioPesa5)Error: La copia del fitxer "+arxiu.obteFitxer().getName()+" ha fallat");
                                                }
                                                else
                                                {
                                                
                                                   Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(rutaNovaImatge.obteCadena()));	
                                                   img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
                                                
                                                   ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
                                                
                                                }
                                             
                                             }
                                             else throw new Exception ("Encara no has seleccionat cap fitxer!!");
                                          }
                                          
                                             catch(Exception e) {                                                     
                                             
                                                System.err.println("(ControlModificacioPesa6)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });									
         
                        ///////////BOTO MODIFICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            modificar=(JButton)(pantalla3.getObject("modificar"));
         
            modificar.addActionListener(
                                 
                                    new ActionListener()                        
                                    {                             
                                    
                                       public void actionPerformed(ActionEvent ae)                                               
                                       {
                                       
                                          ObjectePersistencia op = new ObjectePersistencia();
                                       
                                          String nomPesaModificat,duradaPesaModificat,procedenciaPesaModificat,autorPesaModificat;
                                          String dataCreacioPesaModificat,descripcioPesaModificat;
                                       
                                          nomPesaModificat=((JTextField)(pantalla3.getObject("valorNomModificat"))).getText();
                                          duradaPesaModificat=((JTextField)(pantalla3.getObject("valorDuradaModificat"))).getText();
                                          procedenciaPesaModificat=((JTextField)(pantalla3.getObject("valorProcedenciaModificat"))).getText();
                                          autorPesaModificat=((JTextField)(pantalla3.getObject("valorAutorModificat"))).getText();
                                          dataCreacioPesaModificat=((JTextField)(pantalla3.getObject("valorDataCreacioModificat"))).getText();
                                          descripcioPesaModificat=((JTextArea)(pantalla3.getObject("valorDescripcioModificat"))).getText();
                                       
                                          modificacioSenseProblemes=true;
                                          campsBuits=0;
                                       
                                          if(nomPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomPesaModificat)) {modificacioSenseProblemes=false;}
                                          else
                                          {
                                          
                                             if(duradaPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDurada(duradaPesaModificat)) {modificacioSenseProblemes=false;}
                                             else
                                             {
                                             
                                                if(procedenciaPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(procedenciaPesaModificat)) {modificacioSenseProblemes=false;}
                                                {
                                                
                                                   if(autorPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(autorPesaModificat)) {modificacioSenseProblemes=false;}
                                                   {
                                                   
                                                      if(dataCreacioPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataCreacioPesaModificat)) {modificacioSenseProblemes=false;}
                                                      else
                                                      {
                                                      
                                                         if(descripcioPesaModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDescripcio(descripcioPesaModificat)) {modificacioSenseProblemes=false;}
                                                      
                                                      }
                                                   
                                                   }
                                                
                                                }
                                             
                                             }
                                          
                                          }
                                       
                                          if(nomPesaModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(duradaPesaModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(procedenciaPesaModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(autorPesaModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(dataCreacioPesaModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(descripcioPesaModificat.compareToIgnoreCase("")==0) campsBuits++; 
                                       
                                          if(!modificacioSenseProblemes | (campsBuits==6 & rutaNovaImatge.obteCadena()==""))
                                          {
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()                            
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)                                        
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("dadesNoValides"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {        
                                                
                                                   System.err.println("(ControlModificacioPesa7)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile4 = null;
                                          
                                          }
                                          
                                          else
                                          {
                                          
                                             ((JFrame)(pantalla3.getObject("novesDadesModificacioPesa"))).dispose();
                                          
                                             if( nomPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("nom", nomPesaModificat);
                                             if( duradaPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampHora("durada",duradaPesaModificat);
                                             if( procedenciaPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("procedencia",procedenciaPesaModificat);
                                             if( autorPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("autor",autorPesaModificat);
                                             if( dataCreacioPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataCreacio",dataCreacioPesaModificat);
                                             if( descripcioPesaModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("descripcio",descripcioPesaModificat);
                                          
                                             if(campsBuits<6) RelacioPeces.actualitzaDiversosCampsPesaPerIdentificadorPesa(identificadorPesa,op);
                                          
                                             if(rutaNovaImatge.obteCadena()!="")
                                             {
                                                RelacioImatges relIm = new RelacioImatges();
                                                Imatge imatge = new Imatge();
                                                imatge.estableixRuta(rutaNovaImatge.obteCadena());
                                                int identificador = relIm.afegirImatge(imatge);
                                                RelacioImatgesPesa relImPesa = new RelacioImatgesPesa();
                                                relImPesa.eliminaImatges(identificadorPesa);
                                                relImPesa.afegirImatgeAPesa(identificadorPesa,identificador);
                                             }
                                          
                                             File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                             String nomFitxer5 = docFile5.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                pantalla5.load();
                                                pantalla5.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
                                                acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                     
                                                                     
                                                                        new ActionListener()                 
                                                                        
                                                                        
                                                                        {
                                                                        
                                                                        
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)       
                                                                           
                                                                           
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                             
                                             
                                                catch(Exception e) {        
                                                
                                                
                                                
                                                   System.err.println("(ControlModificacioPesa8)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile5 = null;
                                          
                                          }
                                       
                                          op.destructorObjectePersistencia();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlModificacioPesa9)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }