   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Eines.ImageFileView;
   import Entitats.Eines.ImageFilter;
   import Entitats.Eines.ImagePreview;
   import Entitats.Eines.Utils;
   import Entitats.Eines.CopiaFitxer;
   import Entitats.Eines.Fitxer;
   import Entitats.Eines.Cadena;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Soci.RelacioImatgesSoci;
   import java.sql.Timestamp;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder modificar la informacio
* d'un soci.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlModificacioSoci
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean modificacioSenseProblemes;
      String nomSoci,cognom1Soci,cognom2Soci,identificadorPersonalSoci,adresaSoci;
      String telefonSoci,dataNaixementSoci,numSoci;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari modificar un soci. 
   */
      public ControlModificacioSoci()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_modificacioSoci.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlModificacioSoci()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaModificacioSoci()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(modificacioSenseProblemes && campsBuits<8)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("modificacioSoci"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatSoci.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             String nomICognoms="";
                                             Soci soci = new Soci();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomSoci.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomSoci);
                                                if(cognom1Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom1",cognom1Soci);
                                                if(cognom2Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom2",cognom2Soci);
                                                if(identificadorPersonalSoci.compareToIgnoreCase("")!=0)op.afegirCampText("identificadorPersonal",identificadorPersonalSoci);
                                                if(adresaSoci.compareToIgnoreCase("")!=0)op.afegirCampText("adresa",adresaSoci);
                                                if(telefonSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("telefon",Integer.parseInt(telefonSoci));
                                                if(dataNaixementSoci.compareToIgnoreCase("")!=0)op.afegirCampData("dataNaixement",dataNaixementSoci);
                                                if(numSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("numSoci",Integer.parseInt(numSoci));
                                             
                                                RelacioSocis relacioSocis = new RelacioSocis();
                                                relacioSocis.obteSociPerMultiplesCamps(op);
                                             
                                                while(relacioSocis.hiHaSocis())
                                                {
                                                
                                                   nomICognoms="";
                                                   soci=relacioSocis.obteSoci();
                                                   if(soci.esActiu())
                                                   {
                                                      nomICognoms+=soci.obteCognom1()+" "+soci.obteCognom2()+" , "+soci.obteNom();
                                                      llistat.addItem(nomICognoms,soci.obteNumSoci());
                                                      elementsTrobats++;
                                                   }
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 modificaSoci((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioSocis.destructorRelacioSocis();
                                                soci.destructorSoci();
                                             
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlModificacioSoci1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("modificacioSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlModificacioSoci2)Error: " + e.getMessage());
            
            }
      
      }
   
   
   
      private void capturaIValidaDades()
      
      {
      
         modificacioSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,num;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomSoci=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1=(JTextField)(pantalla.getObject("valorCognom1"));
         cognom1Soci=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2=(JTextField)(pantalla.getObject("valorCognom2"));
         cognom2Soci=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonal=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
         identificadorPersonalSoci=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresa=(JTextField)(pantalla.getObject("valorAdresa"));
         adresaSoci=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefon=(JTextField)(pantalla.getObject("valorTelefon"));
         telefonSoci=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixement=(JTextField)(pantalla.getObject("valorDataNaixement"));
         dataNaixementSoci=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
         num=(JTextField)(pantalla.getObject("valorNumSoci"));
         numSoci=((JTextField)(pantalla.getObject("valorNumSoci"))).getText();
      
         if(nomSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom1Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom2Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(identificadorPersonalSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(adresaSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(telefonSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(dataNaixementSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(numSoci.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomSoci)) modificacioSenseProblemes=false;
         else
         {
         
            if(cognom1.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1Soci)) modificacioSenseProblemes=false;
            else
            {
            
               if(cognom2.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2Soci)) modificacioSenseProblemes=false;
               else
               {
               
                  if(identificadorPersonal.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSoci)) modificacioSenseProblemes=false;
                  else
                  {
                  
                     if(adresa.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaSoci)) modificacioSenseProblemes=false;
                     else
                     {
                     
                        if(telefon.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonSoci)) modificacioSenseProblemes=false;
                        else
                        {
                        
                           if(dataNaixement.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementSoci)) modificacioSenseProblemes=false;
                           else
                           {
                           
                              if(num.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaXifra(numSoci)) modificacioSenseProblemes=false;
                           
                           }
                        }
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(modificacioSenseProblemes==false | campsBuits==8)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlModificacioSoci3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
   
      private void modificaSoci(final int numSoci)
      
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_novesDadesModificacioSoci.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar,obrir,assignar;
         JTextField camp;
      
         final Fitxer arxiu = new Fitxer();
         final Fitxer directoriDesti = new Fitxer();
         final Fitxer fitxerDesti = new Fitxer();
         final Cadena rutaNovaImatge = new Cadena();
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Soci Soci = RelacioSocis.obteSociPerNumSoci(numSoci);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Soci.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom1"));
            camp.setText(Soci.obteCognom1());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom2"));
            camp.setText(Soci.obteCognom2());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorIdentificadorPersonal"));
            camp.setText(Soci.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAdresa"));
            camp.setText(Soci.obteAdresa());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorTelefon"));
            camp.setText(""+Soci.obteTelefon()+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataNaixement"));
            camp.setText(Soci.obteDataNaixement());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorNumSoci"));
            camp.setText(""+numSoci+"");
            camp.setEnabled(false);
         
            RelacioImatgesSoci rel = new RelacioImatgesSoci();
            rel.obteImatgesSoci(Soci.obteNumSoci());
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
            rel.destructorRelacioImatgesSoci();
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("novesDadesModificacioSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
                        ///////////BOTO MODIFICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
            modificar=(JButton)(pantalla3.getObject("modificar"));
         
            modificar.addActionListener(
                                 
                                    new ActionListener()                        
                                    {                             
                                    
                                       public void actionPerformed(ActionEvent ae)                                               
                                       {
                                       
                                          ObjectePersistencia op = new ObjectePersistencia();
                                       
                                          String nomSociModificat,cognom1SociModificat,cognom2SociModificat,identificadorPersonalSociModificat,adresaSociModificat;
                                          String telefonSociModificat,dataNaixementSociModificat;
                                       
                                          nomSociModificat=((JTextField)(pantalla3.getObject("valorNomModificat"))).getText();
                                          cognom1SociModificat=((JTextField)(pantalla3.getObject("valorCognom1Modificat"))).getText();
                                          cognom2SociModificat=((JTextField)(pantalla3.getObject("valorCognom2Modificat"))).getText();
                                          identificadorPersonalSociModificat=((JTextField)(pantalla3.getObject("valorIdentificadorPersonalModificat"))).getText();
                                          adresaSociModificat=((JTextField)(pantalla3.getObject("valorAdresaModificat"))).getText();
                                          telefonSociModificat=((JTextField)(pantalla3.getObject("valorTelefonModificat"))).getText();
                                          dataNaixementSociModificat=((JTextField)(pantalla3.getObject("valorDataNaixementModificat"))).getText();
                                       
                                          modificacioSenseProblemes=true;
                                          campsBuits=0;
                                       
                                          if(nomSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomSociModificat)) {modificacioSenseProblemes=false;}
                                          else
                                          {
                                          
                                             if(cognom1SociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1SociModificat)) {modificacioSenseProblemes=false;}
                                             else
                                             {
                                             
                                                if(cognom2SociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2SociModificat)) {modificacioSenseProblemes=false;}
                                                {
                                                
                                                   if(identificadorPersonalSociModificat.compareToIgnoreCase("")!=0 && (!ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSociModificat) | !RelacioSocis.noExisteix(identificadorPersonalSociModificat)) ) {modificacioSenseProblemes=false;}
                                                   {
                                                   
                                                      if(adresaSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaSociModificat)) {modificacioSenseProblemes=false;}
                                                      else
                                                      {
                                                      
                                                         if(telefonSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonSociModificat)) {modificacioSenseProblemes=false;}
                                                         else
                                                         {
                                                         
                                                            if(dataNaixementSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementSociModificat)) {modificacioSenseProblemes=false;}
                                                         
                                                         }
                                                      
                                                      }
                                                   
                                                   }
                                                
                                                }
                                             
                                             }
                                          
                                          }
                                       
                                          if(nomSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom1SociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom2SociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(identificadorPersonalSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(adresaSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(telefonSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(dataNaixementSociModificat.compareToIgnoreCase("")==0) campsBuits++; 
                                       
                                          if((!modificacioSenseProblemes | campsBuits==7) & rutaNovaImatge.obteCadena()=="")
                                          {
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()                            
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)                                        
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("dadesNoValides"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {        
                                                
                                                   System.err.println("(ControlModificacioSoci4)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile4 = null;
                                          
                                          }
                                          
                                          else
                                          {
                                          
                                             ((JFrame)(pantalla3.getObject("novesDadesModificacioSoci"))).dispose();
                                          
                                             if( nomSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("nom",nomSociModificat);
                                             if( cognom1SociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom1",cognom1SociModificat);
                                             if( cognom2SociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom2",cognom2SociModificat);
                                             if( identificadorPersonalSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("identificadorPersonal",identificadorPersonalSociModificat);
                                             if( adresaSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("adresa",adresaSociModificat);
                                             if( telefonSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampNumeric("telefon",Integer.parseInt(telefonSociModificat));
                                             if( dataNaixementSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataNaixement",dataNaixementSociModificat);
                                          
                                             if(rutaNovaImatge.obteCadena()!="")
                                             {
                                                RelacioImatges relIm = new RelacioImatges();
                                                Imatge imatge = new Imatge();
                                                imatge.estableixRuta(rutaNovaImatge.obteCadena());
                                                int identificador = relIm.afegirImatge(imatge);
                                                RelacioImatgesSoci relImSoci = new RelacioImatgesSoci();
                                                relImSoci.eliminaImatges(numSoci);
                                                relImSoci.afegirImatgeASoci(numSoci,identificador);
                                             }
                                          
                                             if(campsBuits!=7)
                                             {
                                                if(RelacioSocis.actualitzaDiversosCampsSociPerNumSoci(numSoci,op))
                                                {
                                                
                                                   File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                                   String nomFitxer5 = docFile5.getAbsolutePath();
                                                   JButton acceptar;
                                                
                                                   try
                                                   {
                                                   
                                                      final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                      pantalla5.load();
                                                      pantalla5.renderInterface();
                                                   
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
                                                      acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                                   
                                                      acceptar.addActionListener(
                                                                           
                                                                           
                                                                           
                                                                              new ActionListener()                 
                                                                              
                                                                              
                                                                              {
                                                                              
                                                                              
                                                                              
                                                                                 public void actionPerformed(ActionEvent ae)       
                                                                                 
                                                                                 
                                                                                 {
                                                                                 
                                                                                    ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                                 
                                                                                 }
                                                                              
                                                                              });
                                                   
                                                   }
                                                   
                                                   
                                                   
                                                      catch(Exception e) {        
                                                      
                                                      
                                                      
                                                         System.err.println("(ControlModificacioSoci5)Error: " + e.getMessage());
                                                      
                                                      }
                                                
                                                   docFile5 = null;
                                                }
                                             }
                                          
                                          }
                                       
                                          op.destructorObjectePersistencia();
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
            obrir=(JButton)(pantalla3.getObject("obrir"));
         
            obrir.addActionListener(                                                        
                                 
                                 
                                    new ActionListener()                                                
                                    
                                    {                                  
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)                                         
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                             JFileChooser fc;
                                             fc = new JFileChooser();
                                          
                                             fc.addChoosableFileFilter(new ImageFilter());
                                             fc.setAcceptAllFileFilterUsed(false);
                                          
                                             fc.setFileView(new ImageFileView());
                                          
                                             fc.setAccessory(new ImagePreview(fc));
                                          
                                          
                                             int returnVal = fc.showDialog((JFrame)(pantalla3.getObject("novesDadesModificacioSoci")),"Afegir");
                                          
                                             if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File directori = fc.getCurrentDirectory();
                                                arxiu.estableixFitxer(fc.getSelectedFile());
                                                String fitxer = arxiu.obteFitxer().getName();
                                                ((JTextField)(pantalla3.getObject("nomImatge"))).setText(fitxer);
                                             
                                                directoriDesti.estableixFitxer(new File("../Galeria/socis/imatges/"));
                                             
                                                Timestamp time = new Timestamp(System.currentTimeMillis());
                                                String nouFitxer = (time.getTime()+time.getTime())+"--"+fitxer;
                                             
                                                fitxerDesti.estableixFitxer(new File(directoriDesti.obteFitxer(), nouFitxer));
                                             
                                                rutaNovaImatge.estableixCadena("../Galeria/socis/imatges/"+nouFitxer);
                                             
                                             } 
                                          
                                             fc.setSelectedFile(null);
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {        
                                             
                                             
                                             
                                             
                                             
                                                System.err.println("(ControlModificacioSoci6)Error: " + e.getMessage());
                                             
                                             }
                                       
                                       }
                                    
                                    });		
         
              ///////////BOTO ASSIGNAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
            assignar=(JButton)(pantalla3.getObject("assigna"));
         
            assignar.addActionListener(
                                 
                                 
                                    new ActionListener()    
                                    
                                    
                                    
                                    {
                                    
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                          
                                             if(arxiu.obteFitxer()!=null)
                                             {
                                                Long checksumSrc = CopiaFitxer.copia(arxiu.obteFitxer(), fitxerDesti.obteFitxer());
                                             
                                                Long checksumDest = CopiaFitxer.creaChecksum(fitxerDesti.obteFitxer());
                                                if (!checksumSrc.equals(checksumDest)) {
                                                   System.err.println("(ControlModificacioSoci7)Error: La copia del fitxer "+arxiu.obteFitxer().getName()+" ha fallat");
                                                }
                                                else
                                                {
                                                
                                                   Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(rutaNovaImatge.obteCadena()));	
                                                   img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
                                                
                                                   ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
                                                
                                                }
                                             
                                             }
                                             else throw new Exception ("Encara no has seleccionat cap fitxer!!");
                                          
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {                                                     
                                             
                                             
                                                System.err.println("(ControlModificacioSoci8)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });									
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlModificacioSoci9)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }