   import java.io.*;
   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import javax.swing.filechooser.*;


   public class AfegirImatge extends JPanel implements ActionListener 
   {
      private JFileChooser fc;
   
      public AfegirImatge() {
         super(new BorderLayout());
      
         JButton sendButton = new JButton("Afegeix!");
         sendButton.addActionListener(this);
         add(sendButton, BorderLayout.PAGE_START);
      }
   
      public void actionPerformed(ActionEvent e) {
      
         if (fc == null) {
            fc = new JFileChooser();
         
            fc.addChoosableFileFilter(new ImageFilter());
            fc.setAcceptAllFileFilterUsed(false);
         
            fc.setFileView(new ImageFileView());
         
            fc.setAccessory(new ImagePreview(fc));
         }
      
      
         int returnVal = fc.showDialog(AfegirImatge.this,"Afegir");
      
         if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            String fitxer = file.getName();
         } 
         fc.setSelectedFile(null);
      }
   
      public static void main(String[] args) {
      
         JFrame frame = new JFrame("AfegirImatge");
         frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
         JComponent newContentPane = new AfegirImatge();
         newContentPane.setOpaque(true); 
         frame.setContentPane(newContentPane);
      
         frame.pack();
         frame.setVisible(true);
      
      }
   }
