   package Entitats.Eines;

   import Entitats.Actuacio.RelacioImatgesActuacio;
   import Entitats.Pesa.RelacioImatgesPesa;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Soci.RelacioImatgesSoci;
   import Entitats.Imatge.Imatge;
   import java.io.DataOutputStream;
   import java.io.File;
   import java.io.FileOutputStream;


   public class EscriuFitxerImatges
   {
   
      public static void EscriuFitxerActuacions(RelacioImatgesActuacio rel,String nomfitxer)
      {
      
         DataOutputStream dos;
      
         try {
         
            dos = new DataOutputStream(new FileOutputStream("../Actuacio/"+nomfitxer+".dat", false));
         
         //escriu fitxer d'imatges
            while(rel.hiHaImatges())
            {
               Imatge imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge()); 
               dos.writeBytes("[Photo]\n");   
            
               String ruta = imatge.obteRuta();
            
               dos.writeBytes("PhotoURL="+ruta+"\n");
            }
         
            dos.close();
         
            dos = new DataOutputStream(new FileOutputStream("../Actuacio/"+nomfitxer+".htm", true));
         
         //escriu fitxer html
            dos.writeBytes("<HTML>\n");
            dos.writeBytes("<BODY><CENTER>\n");
            dos.writeBytes("<APPLET\n"); 
            dos.writeBytes("ARCHIVE  = \"imatges.class\"\n");
            dos.writeBytes("CODE     = \"imatges.class\"\n"); 
            dos.writeBytes("NAME     = \"Album\"\n"); 
            dos.writeBytes("WIDTH    = 400\n"); 
            dos.writeBytes("HEIGHT   = 400\n"); 
            dos.writeBytes("HSPACE   = 4\n"); 
            dos.writeBytes("VSPACE   = 4\n"); 
            dos.writeBytes("ALIGN    = middle >\n");
            dos.writeBytes("<PARAM NAME=\"PhotoCollectionFileName\"       VALUE=\""+nomfitxer+".dat\">\n");
            dos.writeBytes("<PARAM NAME=\"WipeEffect\"                    VALUE=\"GROWOUTWARD\">\n"); 
            dos.writeBytes("<PARAM NAME=\"HideButtons\"                   VALUE=\"NO\">\n"); 
            dos.writeBytes("<PARAM NAME=\"HideShortDescr\"                VALUE=\"NO\">\n");
            dos.writeBytes("<PARAM NAME=\"HideLongDescr\"                 VALUE=\"YES\">\n"); 
            dos.writeBytes("<PARAM NAME=\"AutoSlideShow\"                 VALUE=\"NO\">\n"); 
            dos.writeBytes("<PARAM NAME=\"OpenBrowserWithImageOnClick\"   VALUE=\"YES\">\n"); 
            dos.writeBytes("<PARAM NAME=\"DelayInSeconds\"                VALUE=\"5\">\n"); 
            dos.writeBytes("<PARAM NAME=\"DisplayLoadingMessage\"         VALUE=\"YES\">\n"); 
            dos.writeBytes("<PARAM NAME=\"DisplayProgressBar\"            VALUE=\"YES\">\n"); 
            dos.writeBytes("<PARAM NAME=\"FirstButtonText\"               VALUE=\"Primer\">\n"); 
            dos.writeBytes("<PARAM NAME=\"NextButtonText\"                VALUE=\"Seguent\">\n"); 
            dos.writeBytes("<PARAM NAME=\"LastButtonText\"                VALUE=\"Ultim\">\n"); 
            dos.writeBytes("<PARAM NAME=\"PreviousButtonText\"            VALUE=\"Anterior\">\n"); 
            dos.writeBytes("<PARAM NAME=\"ShortDescrRows\"                VALUE=\"3\">\n"); 
            dos.writeBytes("<PARAM NAME=\"LongDescrRows\"                 VALUE=\"4\">\n"); 
            dos.writeBytes("<PARAM NAME=\"ShortDescrBgColorHex\"          VALUE=\"0000ff\">\n");  
            dos.writeBytes("<PARAM NAME=\"ShortDescrTextColorHex\"        VALUE=\"ffffff\">\n"); 
            dos.writeBytes("<PARAM NAME=\"LongDescrTextColorHex\"         VALUE=\"ffffff\">\n"); 
            dos.writeBytes("<PARAM NAME=\"LongDescrBgColorHex\"           VALUE=\"0000ff\">\n"); 
            dos.writeBytes("<PARAM NAME=\"PhotoEdgeSpacing\"              VALUE=\"4\">\n"); 
            dos.writeBytes("<PARAM NAME=\"ButtonBarTextColorHex\"         VALUE=\"000000\">\n"); 
            dos.writeBytes("<PARAM NAME=\"ButtonBarBgColorHex\"           VALUE=\"c0c0c0\">\n"); 
            dos.writeBytes("<PARAM NAME=\"PhotoBorderColorHex\"           VALUE=\"ffffff\">\n"); 
            dos.writeBytes("<PARAM NAME=\"CanvasBgColorHex\"              VALUE=\"000000\">\n");
            dos.writeBytes("</APPLET>\n"); 
            dos.writeBytes("</BODY>\n");
            dos.writeBytes("</HTML>");
         
            dos.close();
         
         } 
            catch (Exception e) {
               System.err.println("(EscriuFitxerImatges1)Error: " + e.getMessage());
            } 
      }
   
      public static void EscriuFitxerTotsSocis(RelacioImatgesSoci rel)
      {
      
         DataOutputStream dos;
      
         try {
         
            dos = new DataOutputStream(new FileOutputStream("../Galeria/socis/socis.dat", false));
         
         //escriu fitxer d'imatges
            while(rel.hiHaImatges())
            {
               Imatge imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge()); 
               dos.writeBytes("[Photo]\n");   
            
               String ruta = imatge.obteRuta();
            
               dos.writeBytes("PhotoURL=../"+ruta+"\n");
            }
         
            dos.close();
         
         } 
         
            catch (Exception e) {
            
               System.err.println("(EscriuFitxerImatges2)Error: " + e.getMessage());
            } 
      }	
   
      public static void EscriuFitxerTotesActuacions(RelacioImatgesActuacio rel)
      
      {
      
         DataOutputStream dos;
      
         try {
         
            dos = new DataOutputStream(new FileOutputStream("../Galeria/actuacions/actuacions.dat", false));
         
         //escriu fitxer d'imatges
            while(rel.hiHaImatges())
            {
               Imatge imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge()); 
               dos.writeBytes("[Photo]\n");   
            
               String ruta = imatge.obteRuta();
            
               dos.writeBytes("PhotoURL=../"+ruta+"\n");
            }
         
            dos.close();
         
         } 
         
         
            catch (Exception e) {
            
            
               System.err.println("(EscriuFitxerImatges3)Error: " + e.getMessage());
            } 
      }	
   
      public static void EscriuFitxerTotesPeces(RelacioImatgesPesa rel)
      
      {
      
         DataOutputStream dos;
      
         try {
         
            dos = new DataOutputStream(new FileOutputStream("../Galeria/peces/peces.dat", false));
         
         //escriu fitxer d'imatges
            while(rel.hiHaImatges())
            {
               Imatge imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge()); 
               dos.writeBytes("[Photo]\n");   
            
               String ruta = imatge.obteRuta();
            
               dos.writeBytes("PhotoURL=../"+ruta+"\n");
            }
         
            dos.close();
         
         } 
         
         
            catch (Exception e) {
            
            
               System.err.println("(EscriuFitxerImatges2)Error: " + e.getMessage());
            } 
      }
   
   }