   package Entitats.Eines; 

   import java.lang.reflect.Method; 
   import java.util.Arrays; 
   import javax.swing.JOptionPane; 
   public class Navegador 
   { 
      private static final String error = "Error en intentar executar el navegador predefinit del sistema"; 
      public static void obreURL(String url) { 
         String sistemaOperatiu = System.getProperty("os.name"); 
         try { 
            if (sistemaOperatiu.startsWith("Mac OS")) 
            { 
               Class fileMgr = Class.forName("com.apple.eio.FileManager"); 
               Method openURL = fileMgr.getDeclaredMethod("openURL", new Class[]{String.class}); 
               openURL.invoke(null, new Object[] {url}); 
            } 
            else if (sistemaOperatiu.startsWith("Windows")) Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + url); 
            else { //presoposem Unix o Linux 
               String[] navegadors = { "firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape" }; 
               String navegador = null; 
               for (int count = 0; count < navegadors.length && navegador == null; count++) 
                  if (Runtime.getRuntime().exec( new String[] {"which", navegadors[count]}).waitFor() == 0) navegador = navegadors[count]; 
               if (navegador == null) throw new Exception("No s'ha pogut trobar cap navegador"); 
               else Runtime.getRuntime().exec(new String[] {navegador, url}); 
            } } 
            catch (Exception e) { 
               JOptionPane.showMessageDialog(null, error + ":\n" + e.getLocalizedMessage()); } } }