   import java.applet.Applet;
   import java.applet.AppletContext;
   import java.awt.AWTEvent;
   import java.awt.BorderLayout;
   import java.awt.Button;
   import java.awt.Color;
   import java.awt.Component;
   import java.awt.Container;
   import java.awt.Dimension;
   import java.awt.Font;
   import java.awt.FontMetrics;
   import java.awt.Frame;
   import java.awt.Graphics;
   import java.awt.GridBagLayout;
   import java.awt.GridLayout;
   import java.awt.Image;
   import java.awt.MediaTracker;
   import java.awt.Panel;
   import java.awt.TextArea;
   import java.awt.TextComponent;
   import java.awt.Toolkit;
   import java.awt.Window;
   import java.awt.event.ActionEvent;
   import java.awt.event.ActionListener;
   import java.awt.event.MouseAdapter;
   import java.awt.event.MouseEvent;
   import java.awt.event.WindowEvent;
   import java.io.DataInputStream;
   import java.io.FilterInputStream;
   import java.io.IOException;
   import java.io.PrintStream;
   import java.net.MalformedURLException;
   import java.net.URL;
   import java.net.URLConnection;
   import java.util.Calendar;
   import java.util.Date;
   import java.util.GregorianCalendar;
   import java.util.Random;
   import java.util.Vector;

   public class imatges extends Applet
   implements Runnable
   {
   
      public String getParameter(String key, String def)
      {
         return isStandalone ? System.getProperty(key, def) : getParameter(key) == null ? def : getParameter(key);
      }
   
      public imatges()
      {
         isStandalone = false;
         StartedProgressBar = false;
         thePhotoURL = null;
         borderLayout1 = new BorderLayout();
         VectorIndex = -1;
         ImageTopOffset = 0;
         ImageBottomOffset = 0;
         OverlayFontSize = 12;
         TotalOverlays = 0;
         greyColor = new Color(99, 99, 99);
         OverlayFontColor = "ffffff";
         OverlayOutlineColor = "000000";
         OverlayAlignment = "TOP";
         OverlayText = new String[20];
         FrameName = "_blank";
         Registered = false;
         shortDescrRows = 3;
         longDescrRows = 4;
         shortDescrFontSize = 12;
         photoEdgeSpacing = 4;
         longDescrFontSize = 12;
         wipeEffect = "RANDOM";
         hideLongDescr = false;
         hideShortDescr = false;
         hideButtons = false;
         openBrowserWithImage = "YES";
         autoSlideShow = "NO";
         displayLoadMessage = "NO";
         displayProgressBar = "NO";
         nextButtonText = "Seguent";
         previousButtonText = "Anterior";
         lastButtonText = "Ultim";
         firstButtonText = "Primer";
         borderLayout2 = new BorderLayout();
         DisplayPanel = new Panel();
         gridBagLayout1 = new GridBagLayout();
         SouthPanel = new Panel();
         LongMemo = new TextArea(" ", 3, 80, 1);
         gridLayout1 = new GridLayout(4, 1);
         ButtonFirst = new Button();
         ButtonPrevious = new Button();
         ButtonNext = new Button();
         ButtonLast = new Button();
         ButtonLink = new Button();
         borderLayout3 = new BorderLayout();
         ToolPanel = new Panel();
      }
   
      public void run()
      {
         if(autoSlideShow == null)
         {
            VectorIndex = 0;
            ChangePhoto(0);
            return;
         }
         if(autoSlideShow.equals("0") || autoSlideShow.toUpperCase().equals("NO") || autoSlideShow.toUpperCase().equals("FALSE"))
         {
            VectorIndex = 0;
            ChangePhoto(0);
            return;
         }
         do
         {
            if(Thread.currentThread() != animator)
               break;
            VectorIndex++;
            if(VectorIndex >= VectorTotalItems)
               VectorIndex = 0;
            ChangePhoto(VectorIndex);
            try
            {
               Thread.sleep(delay);
               continue;
            }
               catch(InterruptedException e) { 
               }
            break;
         } while(true);
      }
   
      public void init()
      {
         try
         {
            jbInit();
         }
            catch(Exception e)
            {
               e.printStackTrace();
            }
      }
   
      private void jbInit()
      throws Exception
      {
         tracker = new MediaTracker(this);
         AlbumVector = new Vector();
         PhotoFileName = getParameter("PhotoCollectionFileName");
         if(PhotoFileName == null)
            PhotoFileName = "";
         String strDelay = getParameter("DelayInSeconds");
         if(strDelay != null)
            delay = (new Integer(strDelay)).intValue() * 1000;
         else
            delay = 10000;
         autoSlideShow = getParameter("AutoSlideShow");
         if(autoSlideShow == null)
            autoSlideShow = "NO";
         openBrowserWithImage = getParameter("OpenBrowserWithImageOnClick");
         if(openBrowserWithImage == null)
            openBrowserWithImage = "YES";
         firstButtonText = getParameter("FirstButtonText");
         //if(firstButtonText == null)
         firstButtonText = "Primer";
         //nextButtonText = getParameter("NextButtonText");
         if(nextButtonText == null)
            nextButtonText = "Seguent";
         previousButtonText = getParameter("PreviousButtonText");
         //if(previousButtonText == null)
         previousButtonText = "Anterior";
         lastButtonText = getParameter("LastButtonText");
         //if(lastButtonText == null)
         lastButtonText = "Ultim";
         wipeEffect = getParameter("WipeEffect");
         if(wipeEffect == null)
            wipeEffect = "RANDOM";
         displayLoadMessage = getParameter("DisplayLoadingMessage");
         if(displayLoadMessage == null)
            displayLoadMessage = "NO";
         displayProgressBar = getParameter("DisplayProgressBar");
         if(displayProgressBar == null)
            displayProgressBar = "NO";
         if(displayProgressBar.toUpperCase().equals("YES"))
            displayLoadMessage = "NO";
         canvasBgColor = getParameter("CanvasBgColorHex");
         photoBorderColor = getParameter("PhotoBorderColorHex");
         fileScrollBoxBgColor = getParameter("ShortDescrBgColorHex");
         fileScrollBoxTextColor = getParameter("ShortDescrTextColorHex");
         tiledWallpaperImage = getParameter("TiledWallpaperImage");
         String strShortDescFont = getParameter("ShortDescrFontSize");
         if(strShortDescFont != null)
            shortDescrFontSize = (new Integer(strShortDescFont)).intValue();
         else
            shortDescrFontSize = 12;
         String strEdgeSpace = getParameter("PhotoEdgeSpacing");
         if(strEdgeSpace != null)
            photoEdgeSpacing = (new Integer(strEdgeSpace)).intValue();
         else
            photoEdgeSpacing = 4;
         String strScrollRows = getParameter("ShortDescrRows");
         if(strScrollRows != null)
            shortDescrRows = (new Integer(strScrollRows)).intValue();
         else
            shortDescrRows = 4;
         FileListBox = new java.awt.List(shortDescrRows, false);
         hideShortDescr = false;
         if(getParameter("HideShortDescr") != null && (getParameter("HideShortDescr").toUpperCase().equals("YES") || getParameter("HideShortDescr").equals("1")))
            hideShortDescr = true;
         hideButtons = false;
         if(getParameter("HideButtons") != null && (getParameter("HideButtons").toUpperCase().equals("YES") || getParameter("HideButtons").equals("1")))
            hideButtons = true;
         memoTextColor = getParameter("LongDescrTextColorHex");
         memoBgColor = getParameter("LongDescrBgColorHex");
         hideLongDescr = false;
         if(getParameter("HideLongDescr") != null && (getParameter("HideLongDescr").toUpperCase().equals("YES") || getParameter("HideLongDescr").equals("1")))
            hideLongDescr = true;
         String strMemoRows = getParameter("LongDescrRows");
         if(strMemoRows != null)
            longDescrRows = (new Integer(strMemoRows)).intValue();
         else
            longDescrRows = 4;
         String strLongDescFont = getParameter("LongDescrFontSize");
         if(strLongDescFont != null)
            longDescrFontSize = (new Integer(strLongDescFont)).intValue();
         else
            longDescrFontSize = 12;
         buttonBarBgColor = getParameter("ButtonBarBgColorHex");
         buttonBarTextColor = getParameter("ButtonBarTextColorHex");
         if(buttonBarTextColor == null)
            buttonBarTextColor = "ffffff";
         setLayout(borderLayout2);
         FileListBox.addActionListener(
                                 new ActionListener() {
                                 
                                    public void actionPerformed(ActionEvent e)
                                    {
                                       FileListBox_actionPerformed(e);
                                    }
                                 
                                 });
         DisplayPanel.setEnabled(true);
         DisplayPanel.setVisible(false);
         LongMemo.setText("Description Memo");
         LongMemo.setColumns(80);
         LongMemo.setRows(longDescrRows);
         LongMemo.setFont(new Font("Times New Roman", 0, longDescrFontSize));
         LongMemo.setVisible(!hideLongDescr);
         LongMemo.setBackground(convertColor(memoBgColor));
         LongMemo.setForeground(convertColor(memoTextColor));
         gridLayout1.setRows(1);
         gridLayout1.setColumns(4);
         gridLayout1.setHgap(1);
         gridLayout1.setVgap(1);
         ButtonPrevious.setFont(new Font("Dialog", 0, 10));
         ButtonPrevious.setLabel(previousButtonText);
         ButtonPrevious.addActionListener(
                                 new ActionListener() {
                                 
                                    public void actionPerformed(ActionEvent e)
                                    {
                                       ButtonPrevious_actionPerformed(e);
                                    }
                                 
                                 });
         ButtonPrevious.setBackground(convertColor(buttonBarBgColor));
         ButtonPrevious.setForeground(greyColor);
         ButtonFirst.setActionCommand("");
         ButtonFirst.setFont(new Font("Dialog", 0, 10));
         ButtonFirst.setLabel(firstButtonText);
         ButtonFirst.addActionListener(
                                 new ActionListener() {
                                 
                                    public void actionPerformed(ActionEvent e)
                                    {
                                       ButtonFirst_actionPerformed(e);
                                    }
                                 
                                 });
         ButtonFirst.setBackground(convertColor(buttonBarBgColor));
         ButtonFirst.setForeground(greyColor);
         ButtonLink.setActionCommand("");
         ButtonLink.setFont(new Font("Dialog", 0, 10));
         ButtonLink.setLabel("Link");
         ButtonLink.setBackground(convertColor(buttonBarBgColor));
         ButtonLink.setForeground(convertColor(buttonBarTextColor));
         ButtonLink.setEnabled(true);
         ToolPanel.setLayout(gridLayout1);
         ButtonNext.setFont(new Font("Dialog", 0, 10));
         ButtonNext.setLabel(nextButtonText);
         ButtonNext.addActionListener(
                                 new ActionListener() {
                                 
                                    public void actionPerformed(ActionEvent e)
                                    {
                                       ButtonNext_actionPerformed(e);
                                    }
                                 
                                 });
         ButtonNext.setBackground(convertColor(buttonBarBgColor));
         ButtonNext.setForeground(convertColor(buttonBarTextColor));
         ButtonLast.setFont(new Font("Dialog", 0, 10));
         ButtonLast.setLabel(lastButtonText);
         ButtonLast.addActionListener(
                                 new ActionListener() {
                                 
                                    public void actionPerformed(ActionEvent e)
                                    {
                                       ButtonLast_actionPerformed(e);
                                    }
                                 
                                 });
         ButtonLast.setBackground(convertColor(buttonBarBgColor));
         ButtonLast.setForeground(convertColor(buttonBarTextColor));
         SouthPanel.setLayout(borderLayout3);
         /*addMouseListener(
                            new MouseAdapter() {
                            
                               public void mousePressed(MouseEvent e)
                               {
                                  this_mousePressed(e);
                               }
                            
                            });*/
         add(FileListBox, "North");
         int ButtSize = 28;
         int Rows = (getSize().height - LongMemo.getSize().height - ImageTopOffset) / ButtSize;
         borderLayout2.setHgap(3);
         borderLayout2.setVgap(3);
         getRegistrationFile();
         fillListBox(FileListBox);
         FileListBox.setVisible(!hideShortDescr);
         add(SouthPanel, "South");
         SouthPanel.add(LongMemo, "North");
         SouthPanel.add(ToolPanel, "South");
         ToolPanel.add(ButtonFirst, 0);
         ToolPanel.add(ButtonPrevious, 1);
         ToolPanel.add(ButtonNext, 2);
         ToolPanel.add(ButtonLast, 3);
         ToolPanel.setVisible(!hideButtons);
         LongMemo.setBackground(convertColor(memoBgColor));
         LongMemo.setForeground(convertColor(memoTextColor));
      }
   
      public void start()
      {
         animator = new Thread(this);
         animator.start();
      }
   
      public void stop()
      {
      }
   
      public void destroy()
      {
      }
   
      public String getAppletInfo()
      {
         return "Album Viewer";
      }
   
      public String[][] getParameterInfo()
      {
         return null;
      }
   
      public static void main(String args[])
      {
         imatges applet = new imatges();
         applet.isStandalone = true;
         Frame frame = 
            new Frame() {
            
               protected void processWindowEvent(WindowEvent e)
               {
                  super.processWindowEvent(e);
                  if(e.getID() == 201)
                     System.exit(0);
               }
            
               public synchronized void setTitle(String title)
               {
                  super.setTitle(title);
                  enableEvents(64L);
               }
            
            };
         frame.setTitle("JPhotoViewer");
         frame.add(applet, "Center");
         applet.init();
         applet.start();
         frame.setSize(600, 300);
         Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
         frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
         frame.setVisible(true);
      }
   
      void fillListBox(java.awt.List FileListBox)
      {
         FileListBox.setBackground(convertColor(fileScrollBoxBgColor));
         FileListBox.setForeground(convertColor(fileScrollBoxTextColor));
         FileListBox.setFont(new Font("Times New Roman", 0, shortDescrFontSize));
         if(PhotoFileName == null)
            return;
         String CurrentPhoto = " ";
         try
         {
            try
            {
               ReadAlbumFile(PhotoFileName);
            
            }
               catch(Exception e)
               {
                  FileListBox.add(String.valueOf(String.valueOf(e)).concat(" No s'ha trobat l'album"));
               }
            if(FileListBox.getItemCount() == 0)
               FileListBox.add("No hi ha imatges per mostrar");
         }
            catch(Exception e)
            {
               System.out.println(e);
            }
      }
   
      public void update(Graphics g)
      {
         if(!hideShortDescr)
            ImageTopOffset = FileListBox.getSize().height;
         ImageBottomOffset = SouthPanel.getSize().height;
         Dimension PhotoDimension = size();
         int CanvasHeight = PhotoDimension.height - ImageTopOffset - SouthPanel.getSize().height;
         int CanvasWidth = PhotoDimension.width;
         if(offGraphics == null || PhotoDimension.width != offDimension.width || PhotoDimension.height != offDimension.height)
         {
            offDimension = PhotoDimension;
            offImage = null;
            offImage = createImage(CanvasWidth, CanvasHeight);
            offImageOld = offImage;
            offGraphics = offImage.getGraphics();
         }
         offGraphics.setColor(convertColor(canvasBgColor));
         offGraphics.fillRect(0, 0, CanvasWidth, CanvasHeight);
         DrawWallpaper(offGraphics, CanvasWidth, CanvasHeight);
         if(Photo != null)
         {
            int w = Photo.getWidth(this);
            int h = Photo.getHeight(this);
            int scaledHeight = h;
            int scaledWidth = w;
            if(h < CanvasHeight && w < CanvasWidth)
            {
               offGraphics.drawImage(Photo, (CanvasWidth - w) / 2, (CanvasHeight - h) / 2, null);
               offGraphics.setColor(convertColor(photoBorderColor));
               offGraphics.drawRect((CanvasWidth - w) / 2, (CanvasHeight - h) / 2, w, h);
               offGraphics.drawRect((CanvasWidth - w) / 2 + 1, (CanvasHeight - h) / 2 + 1, w - 2, h - 2);
            } 
            else
            {
               float Ratio = 1.0F;
               if((float)CanvasWidth / (float)w < (float)CanvasHeight / (float)h)
                  Ratio = (float)(CanvasWidth - 1) / (float)w;
               else
                  Ratio = (float)(CanvasHeight - 1) / (float)h;
               scaledHeight = (int)((float)h * Ratio) - photoEdgeSpacing;
               scaledWidth = (int)((float)w * Ratio) - photoEdgeSpacing;
               int left = (CanvasWidth - scaledWidth) / 2;
               int top = (CanvasHeight - scaledHeight) / 2;
               offGraphics.setColor(convertColor(photoBorderColor));
               offGraphics.drawImage(Photo, left, top, scaledWidth, scaledHeight, null);
               offGraphics.drawRect(left, top, scaledWidth, scaledHeight - 1);
               offGraphics.drawRect(left + 1, top + 1, scaledWidth - 2, scaledHeight - 3);
            }
         }
         Photo = null;
         if(OverlayText != null)
            DisplayOverlay(offGraphics);
         WipeEffects(g, ImageTopOffset, CanvasWidth, CanvasHeight);
      }
   
      public void paint(Graphics g)
      {
         if(offImage != null)
            g.drawImage(offImage, 0, ImageTopOffset, null);
      }
   
      public Color convertColor(String colStr)
      {
         if(colStr == null || colStr.length() != 6)
         {
            return new Color(0, 0, 0);
         } 
         else
         {
            int rd = (Integer.valueOf(colStr, 16).intValue() & 0xff0000) >> 16;
            int gn = (Integer.valueOf(colStr, 16).intValue() & 0xff00) >> 8;
            int bl = Integer.valueOf(colStr, 16).intValue() & 0xff;
            return new Color(rd, gn, bl);
         }
      }
   
      void FileListBox_actionPerformed(ActionEvent e)
      {
         int index = FileListBox.getSelectedIndex();
         VectorIndex = index;
         if(VectorIndex > 0 && VectorIndex < VectorTotalItems - 1)
         {
            ButtonFirst.setForeground(convertColor(buttonBarTextColor));
            ButtonNext.setForeground(convertColor(buttonBarTextColor));
            ButtonLast.setForeground(convertColor(buttonBarTextColor));
            ButtonPrevious.setForeground(convertColor(buttonBarTextColor));
         } 
         else
            if(VectorIndex == 0)
            {
               ButtonFirst.setForeground(greyColor);
               ButtonNext.setForeground(convertColor(buttonBarTextColor));
               ButtonLast.setForeground(convertColor(buttonBarTextColor));
               ButtonPrevious.setForeground(greyColor);
            } 
            else
               if(VectorIndex == VectorTotalItems - 1)
               {
                  ButtonFirst.setForeground(convertColor(buttonBarTextColor));
                  ButtonNext.setForeground(greyColor);
                  ButtonLast.setForeground(greyColor);
                  ButtonPrevious.setForeground(convertColor(buttonBarTextColor));
               }
         ChangePhoto(VectorIndex);
      }
   
      public String MakeURL(String url)
      {
         if(IsURL(url))
            return url;
         else
            return GetFullURLTo(url);
      }
   
      public boolean IsURL(String line)
      {
         return line.toUpperCase().startsWith("HTTP:") || line.toUpperCase().startsWith("HTTPS:") || line.toUpperCase().startsWith("FTP:") || line.toUpperCase().startsWith("MAILTO:");
      }
   
      public String GetFullURLTo(String fileName)
      {
         String myURL = getCodeBase().toString();
         if(fileName.toUpperCase().startsWith("HTTP") || fileName.toUpperCase().startsWith("FILE:"))
            return fileName;
         if(myURL.endsWith("/"))
            return String.valueOf(myURL) + String.valueOf(fileName);
         else
            return String.valueOf(myURL.substring(0, myURL.lastIndexOf('/') + 1)) + String.valueOf(fileName);
      }
   
      void ChangePhoto(int VectorIndex)
      {
         CurrentOnClickURL = null;
         TotalOverlays = 0;
         OverlayOutlineColor = "000000";
         OverlayFontColor = "ffffff";
         OverlayFontSize = 14;
         FrameName = "_blank";
         String IndexStr = "Photo Sequence ".concat(String.valueOf(String.valueOf(VectorIndex)));
         String NextIndexStr = String.valueOf(String.valueOf((new StringBuffer("Photo Sequence ")).append(VectorIndex + 1)));
         int idx = AlbumVector.indexOf(IndexStr);
         if(idx == -1)
         {
            Photo = null;
            return;
         }
         thePhotoURL = null;
         LongMemo.selectAll();
         LongMemo.replaceRange("", LongMemo.getSelectionStart(), LongMemo.getSelectionEnd());
         for(int i = idx + 1; i <= idx + 1 + 15 && i < AlbumVector.size(); i++)
         {
            String Line = (String)AlbumVector.elementAt(i);
            if(Line.equals(NextIndexStr))
               break;
            int pos;
            if(Line.toUpperCase().startsWith("PHOTOURL"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  thePhotoURL = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("PHOTOLONGDESC"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  LongMemo.append(String.valueOf(String.valueOf(Line.substring(pos + 1))).concat("\n"));
               continue;
            }
            if(Line.toUpperCase().startsWith("PHOTOONCLICKURL"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  CurrentOnClickURL = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("PHOTOONCLICKFRAME"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  FrameName = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("OVERLAYTEXT"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0 && TotalOverlays < 20)
                  OverlayText[TotalOverlays++] = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("OVERLAYFONTCOLOR"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  OverlayFontColor = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("OVERLAYOUTLINECOLOR"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  OverlayOutlineColor = Line.substring(pos + 1).trim();
               continue;
            }
            if(Line.toUpperCase().startsWith("OVERLAYFONTSIZE"))
            {
               pos = Line.indexOf("=");
               if(pos >= 0)
                  OverlayFontSize = (new Integer(Line.substring(pos + 1).trim())).intValue();
               continue;
            }
            if(!Line.toUpperCase().startsWith("OVERLAYALIGNMENT"))
               continue;
            pos = Line.indexOf("=");
            if(pos >= 0)
               OverlayAlignment = Line.substring(pos + 1).toUpperCase().trim();
         }
      
         LongMemo.select(0, 0);
         FileListBox.select(VectorIndex);
         if(thePhotoURL != null)
         {
            Photo = null;
            System.gc();
            Photo = getImage(getCodeBase(), thePhotoURL);
            scanLines = 0;
            StartedProgressBar = false;
            prevDate = null;
            if(Photo == null);
            tracker.addImage(Photo, 1);
            try
            {
               if(displayLoadMessage.toUpperCase().equals("YES") || displayLoadMessage.equals("1"))
                  LoadingMessage(getGraphics());
               else
                  if(displayProgressBar.toUpperCase().equals("YES") || displayProgressBar.equals("1"))
                     prepareImage(Photo, this);
               tracker.waitForID(1);
               tracker.removeImage(Photo);
               getGraphics().drawImage(offImage, 0, ImageTopOffset, null);
            }
               catch(Exception exception) { 
               }
         }
         ButtonNext.setEnabled(false);
         ButtonNext.setEnabled(true);
         ButtonLast.setEnabled(false);
         ButtonLast.setEnabled(true);
         ButtonPrevious.setEnabled(false);
         ButtonPrevious.setEnabled(true);
         ButtonFirst.setEnabled(false);
         ButtonFirst.setEnabled(true);
         repaint();
      }
   
      public void LoadingMessage(Graphics g)
      {
         if((displayProgressBar.toUpperCase().equals("NO") || displayProgressBar.equals("0")) && (displayLoadMessage.toUpperCase().equals("NO") || displayLoadMessage.equals("0")))
            return;
         if(!hideShortDescr)
            ImageTopOffset = FileListBox.getSize().height;
         ImageBottomOffset = SouthPanel.getSize().height;
         g.setFont(new Font("Dialog", 1, 16));
         int Percentage = (int)(progressPerc * 100F);
         String TextString = String.valueOf(String.valueOf((new StringBuffer("Carregant... ")).append(VectorIndex + 1).append(" de ").append(VectorTotalItems)));
         int FontHeight = g.getFontMetrics().getHeight();
         int top = getSize().height;
         int middle = (top - ImageTopOffset - ImageBottomOffset) / 2;
         top = middle + 1 * FontHeight;
         top += 8;
         int stringWidth = g.getFontMetrics().stringWidth(TextString);
         int stringHeight = g.getFontMetrics().getHeight();
         if(displayProgressBar.toUpperCase().equals("YES") || displayProgressBar.equals("1"))
         {
            stringWidth = 100;
            stringHeight = 20;
         }
         int left = getSize().width / 2 - stringWidth / 2;
         if(displayLoadMessage.toUpperCase().equals("YES") || displayLoadMessage.equals("1"))
            DisplayText(g, TextString, left, top, Color.yellow, Color.black, 16);
         if(displayProgressBar.toUpperCase().equals("YES") || displayProgressBar.equals("1"))
         {
            g.setColor(Color.yellow);
            g.fill3DRect(left, top, Percentage, stringHeight, true);
            g.setColor(Color.gray);
            g.fill3DRect(left + Percentage, top, (100 - Percentage) + 1, stringHeight, true);
            g.setColor(Color.black);
            g.drawRect(left - 1, top - 1, 102, 21);
            g.drawRect(left, top, 100, 20);
            g.setColor(Color.black);
            g.drawString(String.valueOf(String.valueOf(Percentage)).concat("%"), left + 5, top + 16);
            if(Percentage == 100)
               try
               {
                  Thread.sleep(200L);
               }
                  catch(Exception exception) { 
                  }
         }
      }
   
      public void DisplayOverlay(Graphics g)
      {
         if(TotalOverlays == 0)
            return;
         g.setFont(new Font("Dialog", 1, OverlayFontSize));
         for(int i = 0; i < TotalOverlays; i++)
         {
            int stringWidth = g.getFontMetrics().stringWidth(OverlayText[i]);
            int left = (getSize().width - stringWidth) / 2;
            int top = getSize().height;
            int FontHeight = g.getFontMetrics().getHeight();
            if(OverlayAlignment.equals("MIDDLE") || OverlayAlignment.equals("CENTER"))
            {
               int middle = (top - ImageTopOffset - ImageBottomOffset) / 2 - (TotalOverlays * FontHeight) / 2;
               top = middle + i * FontHeight;
               top += FontHeight;
            } 
            else
               if(OverlayAlignment.equals("BOTTOM"))
               {
                  top -= ImageBottomOffset + ImageTopOffset;
                  top -= (TotalOverlays - i - 1) * FontHeight;
                  top -= 4;
               } 
               else
               {
                  top = (FontHeight - FontHeight / 4) + i * g.getFontMetrics().getHeight();
               }
            DisplayText(g, OverlayText[i], left, top, convertColor(OverlayFontColor), convertColor(OverlayOutlineColor), OverlayFontSize);
         }
      
      }
   
      public void DisplayText(Graphics g, String TextString, int left, int top, Color Text, Color Outline, int fontSize)
      {
         g.setColor(Outline);
         g.setFont(new Font("Dialog", 1, fontSize));
         g.drawString(TextString, left, top - 1);
         g.drawString(TextString, left - 1, top);
         g.drawString(TextString, left + 1, top);
         g.drawString(TextString, left, top + 1);
         g.setColor(Text);
         g.setFont(new Font("Dialog", 1, fontSize));
         g.drawString(TextString, left, top);
      }
   
      public void WipeEffects(Graphics g, int top, int w, int h)
      {
         int centerX = w / 2;
         int centerY = h / 2;
         g.setColor(convertColor(canvasBgColor));
         int larger = w;
         if(h > w)
            larger = h;
         Random r = new Random();
         int item = 0;
         if(wipeEffect.toUpperCase().equals("RANDOM"))
            item = (int)((double)r.nextFloat() * 4D);
         else
            if(wipeEffect.toUpperCase().equals("GROWOUTWARD"))
               item = 0;
            else
               if(wipeEffect.toUpperCase().equals("CHECKERBOARD"))
                  item = 1;
               else
                  if(wipeEffect.toUpperCase().equals("DIAGONAL"))
                     item = 2;
                  else
                     if(wipeEffect.toUpperCase().equals("CURTAIN"))
                        item = 3;
                     else
                        if(wipeEffect.toUpperCase().equals("NONE"))
                        {
                           g.drawImage(offImage, 0, top, null);
                           return;
                        }
         if(item == 0)
         {
            int increment = 2;
            if(larger < 200)
               increment = 2;
            else
               if(larger >= 200 && larger < 400)
                  increment = 4;
               else
                  if(larger >= 400 && larger < 600)
                     increment = 6;
                  else
                     if(larger >= 600)
                        increment = 8;
            for(int i = 0; i < larger / 2 + increment; i += increment)
            {
               g.setClip(centerX - i, (centerY - i) + top, i * 2, i * 2);
               g.drawImage(offImage, 0, top, null);
               try
               {
                  Thread.sleep(7L);
               }
                  catch(Exception exception3) { 
                  }
            }
         
         }
         if(item == 1)
         {
            int increment = 20;
            if(larger < 200)
               increment = 15;
            else
               if(larger >= 200 && larger < 400)
                  increment = 30;
               else
                  if(larger >= 400 && larger < 600)
                     increment = 40;
                  else
                     if(larger >= 600)
                        increment = 60;
            for(int y = 0; y < h + increment * 2; y += increment * 2)
            {
               for(int x = 0; x < w + increment * 2; x += increment * 2)
               {
                  g.setClip(x, y, increment, increment);
                  g.drawImage(offImage, 0, top, null);
                  g.setClip(x + increment, y + increment, increment, increment);
                  g.drawImage(offImage, 0, top, null);
                  try
                  {
                     Thread.sleep(15L);
                  }
                     catch(Exception exception6) { 
                     }
               }
            
            }
         
            for(int y = 0; y < h + increment * 2; y += increment * 2)
            {
               for(int x = 0; x < w + increment * 2; x += increment * 2)
               {
                  g.setClip(x + increment, y, increment, increment);
                  g.drawImage(offImage, 0, top, null);
                  g.setClip(x, y + increment, increment, increment);
                  g.drawImage(offImage, 0, top, null);
                  try
                  {
                     Thread.sleep(15L);
                  }
                     catch(Exception exception7) { 
                     }
               }
            
            }
         
         } 
         else
            if(item == 2)
            {
               int increment = 6;
               if(larger < 200)
                  increment = 2;
               else
                  if(larger >= 200 && larger < 400)
                     increment = 4;
                  else
                     if(larger >= 400 && larger < 600)
                        increment = 8;
                     else
                        if(larger >= 600)
                           increment = 16;
               for(int i = 1; i <= larger + increment; i += increment)
               {
                  g.setClip(0, top, i >= w ? w : i, i >= h ? h : i);
                  g.drawImage(offImage, 0, top, null);
                  try
                  {
                     Thread.sleep(5L);
                  }
                     catch(Exception exception4) { 
                     }
               }
            
            } 
            else
               if(item == 3)
               {
                  int increment = 1;
                  if(larger < 200)
                     increment = 2;
                  else
                     if(larger >= 200 && larger < 400)
                        increment = 3;
                     else
                        if(larger >= 400 && larger < 600)
                           increment = 5;
                        else
                           if(larger >= 600)
                              increment = 8;
                  for(int i = 0; i < larger / 2 + increment; i += increment)
                  {
                     g.setClip(centerX - i, top, i * 2, h);
                     g.drawImage(offImage, 0, top, null);
                     try
                     {
                        Thread.sleep(5L);
                     }
                        catch(Exception exception5) { 
                        }
                  }
               
               } 
               else
                  if(item == 3)
                  {
                     for(int i = 1; i <= h; i += 3)
                     {
                        g.setClip(0, top, w, i);
                        g.drawImage(offImage, 0, top, null);
                        try
                        {
                           Thread.sleep(5L);
                        }
                           catch(Exception exception) { 
                           }
                     }
                  
                  } 
                  else
                     if(item == 4)
                     {
                        for(int i = 0; i <= h; i += 3)
                        {
                           g.setClip(0, (h - i) + top, w, i);
                           g.drawImage(offImage, 0, top, null);
                           try
                           {
                              Thread.sleep(5L);
                           }
                              catch(Exception exception1) { 
                              }
                        }
                     
                     } 
                     else
                        if(item == 5)
                        {
                           for(int x = 0; x <= w; x += 3)
                           {
                              g.setClip(0, top, x, larger);
                              g.drawImage(offImage, 0, top, null);
                              try
                              {
                                 Thread.sleep(5L);
                              }
                                 catch(Exception exception2) { 
                                 }
                           }
                        
                        }
      }
   
      public void ReadAlbumFile(String URLtoAlbumFile)
      throws SecurityException, IOException, MalformedURLException
      {
         try
         {
            URLtoAlbumFile = MakeURL(URLtoAlbumFile);
            URL u = new URL(URLtoAlbumFile);
            URLConnection connection = u.openConnection();
            connection.setUseCaches(false);
            DataInputStream in = new DataInputStream(connection.getInputStream());
            VectorTotalItems = 0;
            VectorIndex = -1;
            do
            {
               String Line;
               if((Line = in.readLine()) == null)
                  break;
               InsertTag(Line);
               if(Registered || VectorTotalItems != 31)
                  continue;
               VectorTotalItems--;
               break;
            } while(true);
            in.close();
         }
            catch(Exception e)
            {
               System.out.println(e.toString());
               showStatus(e.toString());
            }
      }
   
      public void InsertTag(String Tag)
      {
         if(Tag == null)
            return;
         if(Tag.length() == 0)
            return;
         String Sentinel = new String("Photo Sequence ".concat(String.valueOf(String.valueOf(VectorTotalItems))));
         if(Tag.toUpperCase().startsWith("[PHOTO]"))
         {
            AlbumVector.addElement(Sentinel);
            VectorTotalItems++;
         } 
         else
            if(Tag.toUpperCase().startsWith("PHOTOURL") || Tag.toUpperCase().startsWith("PHOTOSHORTDESC") || Tag.toUpperCase().startsWith("PHOTOLONGDESC") || Tag.toUpperCase().startsWith("OVERLAYTEXT") || Tag.toUpperCase().startsWith("OVERLAYFONTSIZE") || Tag.toUpperCase().startsWith("OVERLAYFONTCOLOR") || Tag.toUpperCase().startsWith("OVERLAYOUTLINECOLOR") || Tag.toUpperCase().startsWith("OVERLAYALIGNMENT") || Tag.toUpperCase().startsWith("PHOTOONCLICKFRAME") || Tag.toUpperCase().startsWith("PHOTOONCLICKURL"))
            {
               if(Tag.toUpperCase().startsWith("PHOTOURL"))
               {
                  int pos = Tag.indexOf("=");
                  if(pos >= 0)
                  {
                     String URL = Tag.substring(pos + 1).trim();
                     FileListBox.add(URL);
                  }
               }
               if(Tag.toUpperCase().startsWith("PHOTOSHORTDESC"))
               {
                  int pos = Tag.indexOf("=");
                  if(pos >= 0)
                  {
                     if(FileListBox.getItemCount() > 0)
                        FileListBox.remove(FileListBox.getItemCount() - 1);
                     FileListBox.add(Tag.substring(pos + 1).trim());
                  }
               }
               AlbumVector.addElement(Tag.trim());
            }
      }
   
      boolean checkRegKey(String regKey)
      {
         String Faker = "569J";
         String Faker2 = Faker.substring(3, 4);
         if(regKey == null)
            return false;
         return regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8900-459999-43343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8900-FFF999-53343-1220")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("R8900-459999-63343-6600")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("D8900-34GGG9-73343-1260")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("D8900-454499-86743-6700")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8900-459999-93DD3-8800")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("B8900-45BB99-03343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("D8900-45BB99-188V3-8800")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("B8900-459999-23343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("X8900-459999-3V343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("A8900-459999-43343-S200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("Q8900-433339-5DD43-D200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("SB900-459999-6G343-GG00")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("R8900-459999-73GG3-1HH0")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("Y8900-459999-833GG-1H00")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("M8RR0-4RRRR9-98FF3-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("N8900-459999-0934F-1RR0")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("B8GG0-455559-9FFF3-1550")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8900-49BB99-83343-1670")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8TT0-459999-73343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("K8900-45TTT9-63343-1200")) || regKey.equals(String.valueOf(String.valueOf(Faker2)).concat("44500-559999-63343-1200"));
      }
   
      void DrawWallpaper(Graphics g, int canvasWidth, int canvasHeight)
      {
         if(tiledWallpaperImage == null)
            return;
         if(WallpaperImage == null)
         {
            WallpaperImage = getImage(getCodeBase(), tiledWallpaperImage);
            if(WallpaperImage != null)
               tracker.removeImage(WallpaperImage);
            tracker.addImage(WallpaperImage, 2);
            try
            {
               tracker.waitForID(2);
            }
               catch(Exception e)
               {
                  tiledWallpaperImage = null;
               }
         }
         if(tiledWallpaperImage == null)
            return;
         int tileWidth = WallpaperImage.getWidth(this);
         int tileHeight = WallpaperImage.getHeight(this);
         if(tileWidth <= 0 || tileHeight <= 0)
            return;
         for(int x = 0; x < canvasWidth + tileWidth; x += tileWidth)
         {
            for(int y = 0; y < canvasHeight + tileHeight; y += tileHeight)
               g.drawImage(WallpaperImage, x, y, null);
         
         }
      
      }
   
      void InvokeBrowser(String theURL, String FrameName)
      {
         try
         {
            getAppletContext().showDocument(new URL(theURL), FrameName);
         }
            catch(MalformedURLException ex)
            {
               showStatus(String.valueOf(String.valueOf((new StringBuffer("URL ")).append(theURL).append(" not found"))));
            }
      }
   
      void this_mousePressed(MouseEvent e)
      {
         if(!Registered)
            InvokeBrowser("http://www.galleriasoftware.com", "_blank");
         else
            if(CurrentOnClickURL != null && CurrentOnClickURL.length() > 0)
               InvokeBrowser(CurrentOnClickURL, FrameName);
            else
               if(openBrowserWithImage.toUpperCase().equals("YES"))
                  InvokeBrowser(GetFullURLTo(thePhotoURL), FrameName);
      }
   
      public void getRegistrationFile()
      throws SecurityException, IOException, MalformedURLException
      {
         try
         {
            String URLtoAlbumFile = MakeURL("key.ser");
            URL u = new URL(URLtoAlbumFile);
            URLConnection connection = u.openConnection();
            connection.setUseCaches(false);
            DataInputStream in = new DataInputStream(connection.getInputStream());
            String RegKey;
            if((RegKey = in.readLine()) != null && checkRegKey(RegKey))
               Registered = true;
            in.close();
         }
            catch(Exception e)
            {
               System.out.println(e.toString());
               showStatus(e.toString());
            }
      }
   
      void ButtonFirst_actionPerformed(ActionEvent e)
      {
         if(VectorIndex == 0)
         {
            return;
         } 
         else
         {
            VectorIndex = 0;
            ButtonNext.setForeground(convertColor(buttonBarTextColor));
            ButtonLast.setForeground(convertColor(buttonBarTextColor));
            ButtonPrevious.setForeground(greyColor);
            ButtonFirst.setForeground(greyColor);
            ChangePhoto(VectorIndex);
            return;
         }
      }
   
      void ButtonPrevious_actionPerformed(ActionEvent e)
      {
         if(VectorIndex <= 0)
            return;
         VectorIndex--;
         if(VectorIndex == 0)
         {
            ButtonPrevious.setForeground(greyColor);
            ButtonFirst.setForeground(greyColor);
         }
         ButtonNext.setForeground(convertColor(buttonBarTextColor));
         ButtonLast.setForeground(convertColor(buttonBarTextColor));
         ChangePhoto(VectorIndex);
      }
   
      void ButtonNext_actionPerformed(ActionEvent e)
      {
         if(VectorIndex >= VectorTotalItems - 1)
            return;
         if(VectorIndex == -1)
            VectorIndex = 0;
         VectorIndex++;
         if(VectorIndex == VectorTotalItems - 1)
         {
            ButtonNext.setForeground(greyColor);
            ButtonLast.setForeground(greyColor);
         }
         ButtonPrevious.setForeground(convertColor(buttonBarTextColor));
         ButtonFirst.setForeground(convertColor(buttonBarTextColor));
         ChangePhoto(VectorIndex);
      }
   
      void ButtonLast_actionPerformed(ActionEvent e)
      {
         if(VectorIndex == VectorTotalItems - 1)
         {
            return;
         } 
         else
         {
            VectorIndex = VectorTotalItems - 1;
            ButtonNext.setForeground(greyColor);
            ButtonLast.setForeground(greyColor);
            ButtonPrevious.setForeground(convertColor(buttonBarTextColor));
            ButtonFirst.setForeground(convertColor(buttonBarTextColor));
            ChangePhoto(VectorIndex);
            return;
         }
      }
   
      public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
      {
         if((infoflags & 1) != 0)
            scanLines = height;
         if((infoflags & 8) != 0)
         {
            if(scanLines >= 0)
            {
               Calendar calendar = new GregorianCalendar();
               currDate = calendar.getTime();
               progressPerc = (float)y / (float)scanLines;
               if(prevDate != null && currDate.getTime() - prevDate.getTime() > (long)400)
               {
                  StartedProgressBar = true;
                  LoadingMessage(getGraphics());
                  prevDate = currDate;
               }
               if(prevDate == null)
                  prevDate = currDate;
            } 
            else
            {
               progressPerc = 0.0F;
            }
            return true;
         }
         if((infoflags & 0x20) != 0)
         {
            scanLines = height;
            progressPerc = 1.0F;
            if(StartedProgressBar)
               LoadingMessage(getGraphics());
            return false;
         } 
         else
         {
            return true;
         }
      }
   
      boolean isStandalone;
      static final int MaxElements = 15;
      static final int ConstPhotoURL = 0;
      static final int ConstPhotoShortDesc = 1;
      static final int ConstPhotoOnClickURL = 2;
      static final int ConstPhotoLongDesc = 4;
      static final int MaxOverlays = 20;
      float progressPerc;
      int scanLines;
      boolean StartedProgressBar;
      Date currDate;
      Date prevDate;
      String thePhotoURL;
      Dimension offDimension;
      Image offImage;
      Image offImageOld;
      Image WallpaperImage;
      Image Photo;
      Graphics offGraphics;
      BorderLayout borderLayout1;
      int frame;
      int delay;
      int VectorIndex;
      int VectorTotalItems;
      int ImageTopOffset;
      int ImageBottomOffset;
      int OverlayFontSize;
      int TotalOverlays;
      Color greyColor;
      Thread animator;
      MediaTracker tracker;
      Vector AlbumVector;
      String CurrentOnClickURL;
      String OverlayFontColor;
      String OverlayOutlineColor;
      String OverlayAlignment;
      String OverlayText[];
      String FrameName;
      boolean Registered;
      String PhotoFileName;
      int shortDescrRows;
      int longDescrRows;
      int shortDescrFontSize;
      int photoEdgeSpacing;
      int longDescrFontSize;
      String buttonBarBgColor;
      String buttonBarTextColor;
      String fileScrollBoxTextColor;
      String fileScrollBoxBgColor;
      String canvasBgColor;
      String memoBgColor;
      String memoTextColor;
      String wipeEffect;
      String photoBorderColor;
      boolean hideLongDescr;
      boolean hideShortDescr;
      boolean hideButtons;
      String openBrowserWithImage;
      String autoSlideShow;
      String displayLoadMessage;
      String displayProgressBar;
      String nextButtonText;
      String previousButtonText;
      String lastButtonText;
      String firstButtonText;
      String tiledWallpaperImage;
      java.awt.List FileListBox;
      BorderLayout borderLayout2;
      Panel DisplayPanel;
      GridBagLayout gridBagLayout1;
      Panel SouthPanel;
      TextArea LongMemo;
      GridLayout gridLayout1;
      Button ButtonFirst;
      Button ButtonPrevious;
      Button ButtonNext;
      Button ButtonLast;
      Button ButtonLink;
      BorderLayout borderLayout3;
      Panel ToolPanel;
   
   }
