   package Entitats.UsuariAplicacio;

/**
* Classe que permet treballar amb usuaris que formaran part del nostre sistema, que tindran acces a certes parts de la
* nostra aplicaci o potser a totes.
*@author Jordi Moles i Blanco, Febrer 2006
*/

   public class UsuariAplicacio
   {
   
      private String usuari;
      private String contrasenya;
      private int nivell;
   
   /**
   * Constructor de la classe
   */
      public UsuariAplicacio()
      {
      
         usuari="";
         contrasenya="";
         nivell=0;
      
      }
   
   /**
   * Metode per establir el nom d'usuari
   *@param usuari String amb el nom d'usuari
   */
      public void estableixUsuari(String usuari)
      {
      
         this.usuari=usuari;
      
      }
   
   /**
   * Metode que permet establir el password
   *@param contrasenya String amb el valor corresponent
   */
      public void estableixContrasenya(String contrasenya)
      {
      
         this.contrasenya=contrasenya;
      
      }
   
   /**
   * Metode per establir el nivell d'un usuari
   *@param nivell Enter amb el valor numeric del nivell
   */
      public void estableixNivell(int nivell)
      {
      
         this.nivell=nivell;
      
      }
   
   /**
   * Metode que ens permet obtenir el nom d'usuari actual
   *@return String amb el valor actual
   */
      public String obteUsuari()
      {
      
         return usuari;
      
      }
   
   /**
   * Metode que ens permet obtenir el password actual
   *@return String amb el valor actual
   */
      public String obteContrasenya()
      {
      
         return contrasenya;
      
      }
   
   /**
   * Metode que ens permet obtenir el nivell d'usuari actual
   *@return Enter amb el valor
   */
      public int obteNivell()
      {
      
         return nivell;
      
      }
   
   }