   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.Temps.Data;
   import Entitats.Soci.Soci;
   import Entitats.Participant.Participant;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder crear un nou participant
*@author Jordi Moles i Blanco, Abril 2005
*/

   public class ControlAltaParticipant
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
      String nomParticipant,cognom1Participant,cognom2Participant,identificadorPersonalParticipant,adresaParticipant;
      String telefonParticipant,dataNaixementParticipant;
      boolean altaSenseProblemes;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre afegir participants al sistema. 
   */
      public ControlAltaParticipant()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_altaParticipant.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlAltaParticipant()
      {
      
         pantalla=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaAltaParticipant()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          int existeixParticipant=0;
                                          boolean existeixParticipantAmbNoms=false;
                                       
                                          capturaIValidaNovesDades();
                                          existeixParticipant = RelacioParticipants.Existeix(identificadorPersonalParticipant);
                                          existeixParticipantAmbNoms = RelacioParticipants.ExisteixAmbNoms(nomParticipant,cognom1Participant,cognom2Participant);
                                       
                                          if(altaSenseProblemes && existeixParticipant==-1 && !existeixParticipantAmbNoms)
                                          {  
                                             ((JFrame)(pantalla.getObject("altaParticipant"))).dispose();
                                             Participant participant = new Participant();
                                             participant.estableixNom(nomParticipant);
                                             participant.estableixCognom1(cognom1Participant);
                                             participant.estableixCognom2(cognom2Participant);
                                             participant.estableixIdentificadorPersonal(identificadorPersonalParticipant);
                                             participant.estableixAdresa(adresaParticipant);
                                             if(telefonParticipant.compareToIgnoreCase("")!=0)participant.estableixTelefon(Integer.parseInt(telefonParticipant));
                                             if(dataNaixementParticipant.compareToIgnoreCase("")!=0)participant.estableixDataNaixement(dataNaixementParticipant);                                                                              
                                          
                                             int valorIntNumSoci=RelacioParticipants.afegirParticipant(participant);
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_participantCreat.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                                if(valorIntNumSoci>0)
                                                { 
                                                   final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                   pantalla4.load();
                                                   pantalla4.renderInterface();
                                                   JTextField valorNumSoci;
                                                
                                                   valorNumSoci=(JTextField)(pantalla4.getObject("valorNumSoci"));
                                                   valorNumSoci.setText(""+valorIntNumSoci+"");
                                                   valorNumSoci.setEnabled(false);
                                                
                                                
                                                
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                   acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla4.getObject("participantCreat"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   valorNumSoci=null;
                                                
                                                }
                                             
                                             }
                                             
                                                catch(Exception e) {   
                                                
                                                   System.err.println("(ControlAltaParticipant1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             participant.destructorSoci();
                                             docFile4=null;
                                          
                                          }
                                          else
                                          {   
                                             if(altaSenseProblemes)
                                             { 
                                                Participant participant = RelacioParticipants.obteParticipantPerIdentificadorPersonal(identificadorPersonalParticipant);
                                                if(participant.obteNumSoci()==0 & existeixParticipantAmbNoms)
                                                { 
                                                   ObjectePersistencia o = new ObjectePersistencia();
                                                   o.afegirCampText("nom",nomParticipant);
                                                   o.afegirCampText("cognom1",cognom1Participant);
                                                   o.afegirCampText("cognom2",cognom2Participant);
                                                   RelacioSocis rela = new RelacioSocis();
                                                   rela.obteSociPerMultiplesCamps(o);
                                                   if(rela.hiHaSocis())
                                                   {	
                                                      participant.estableixNumSoci(rela.obteSoci().obteNumSoci());
                                                   }
                                                   rela.destructorRelacioSocis();
                                                } 
                                                ((JFrame)(pantalla.getObject("altaParticipant"))).dispose();
                                             
                                                if(existeixParticipant==0 | existeixParticipantAmbNoms)
                                                { 
                                                   RelacioParticipants.afegirNomesParticipant(participant.obteNumSoci());
                                                   //soci pero no participant
                                                   if(!participant.esActiu())
                                                   { 
                                                      ((JFrame)(pantalla.getObject("altaParticipant"))).dispose();
                                                      ControlTornadaSoci cts = new ControlTornadaSoci();
                                                      cts.iniciaTornadaSoci((Soci)participant);
                                                   }
                                                   else
                                                   {	
                                                      File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                                      String nomFitxer5 = docFile5.getAbsolutePath();
                                                      JButton acceptar;
                                                   
                                                      try
                                                      {
                                                      
                                                         final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                         pantalla5.load();
                                                         pantalla5.renderInterface();
                                                      
                                                      ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                         acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                                      
                                                         acceptar.addActionListener(
                                                                              
                                                                              
                                                                                 new ActionListener()                 
                                                                                 
                                                                                 {
                                                                                 
                                                                                 
                                                                                    public void actionPerformed(ActionEvent ae)       
                                                                                    
                                                                                    {
                                                                                    
                                                                                       ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                                    
                                                                                    }
                                                                                 
                                                                                 });
                                                      
                                                      }
                                                      
                                                      
                                                         catch(Exception e) {        
                                                         
                                                         
                                                            System.err.println("(ControlAltaParticipant2)Error: " + e.getMessage());
                                                         
                                                         }
                                                   
                                                      docFile5 = null;
                                                   }
                                                }
                                                else
                                                {
                                                //soci i participant
                                                   if(!participant.esActiu())
                                                   {
                                                      ((JFrame)(pantalla.getObject("altaParticipant"))).dispose();
                                                      ControlTornadaSoci cts = new ControlTornadaSoci();
                                                      cts.iniciaTornadaSoci((Soci)participant);
                                                   }
                                                   else
                                                   {
                                                      File docFile3 = new File(".././GUI/SGEC_GUI_participantExistent.jar");
                                                      String nomFitxer3 = docFile3.getAbsolutePath();
                                                      JButton acceptar;
                                                   
                                                      try
                                                      {
                                                      
                                                         final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                         pantalla3.load();
                                                         pantalla3.renderInterface();
                                                      
                                                      ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
                                                         acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                      
                                                         acceptar.addActionListener(
                                                                              
                                                                              
                                                                              
                                                                                 new ActionListener()    
                                                                                 
                                                                                 {
                                                                                 
                                                                                 
                                                                                    public void actionPerformed(ActionEvent ae) 
                                                                                    
                                                                                    {
                                                                                    
                                                                                       ((JFrame)(pantalla3.getObject("participantExistent"))).dispose();
                                                                                    
                                                                                    }
                                                                                 
                                                                                 });
                                                      
                                                      
                                                      }
                                                      
                                                      
                                                         catch(Exception e) {        
                                                         
                                                         
                                                         
                                                            System.err.println("(ControlAltaParticipant3)Error: " + e.getMessage());
                                                         
                                                         }
                                                   
                                                      docFile3=null;
                                                   }
                                                
                                                }
                                             
                                                participant.destructorParticipant();
                                             
                                             }
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("altaParticipant"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlAltaParticipant4)Error: " + e.getMessage());
            
            } 
      
      }
   
      private void capturaIValidaNovesDades()
      {
      
         altaSenseProblemes = true;
      
         nomParticipant=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1Participant=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2Participant=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonalParticipant=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresaParticipant=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefonParticipant=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixementParticipant=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
      
         //validar dades
      
         if(nomParticipant.compareToIgnoreCase("")==0)
         { 
            altaSenseProblemes=false;
         }
         else
            if(!ValidadorFormulariEntrada.validaNom(nomParticipant)) 
            {
               altaSenseProblemes=false;
            }
      
         if(cognom1Participant.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaNom(cognom1Participant))
            { 
               altaSenseProblemes=false;
            }
      
         if(identificadorPersonalParticipant.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalParticipant))
            { 
               altaSenseProblemes=false;
            }
      
      
         if(cognom2Participant.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaNom(cognom2Participant)) altaSenseProblemes=false;
         else
         {
            if(adresaParticipant.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaAdresa(adresaParticipant)) altaSenseProblemes=false;
            else
            {
               if(telefonParticipant.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaTelefon(telefonParticipant)) altaSenseProblemes=false;
               else
               {
                  if(dataNaixementParticipant.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaData(dataNaixementParticipant)) altaSenseProblemes=false;
               
               }
            }
         }
      
      
         if(altaSenseProblemes==false)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_error.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
            JLabel mis1,mis2;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
            
               pantalla2.load();
               pantalla2.renderInterface();
            
               mis1=(JLabel)(pantalla2.getObject("mis1"));
               mis2=(JLabel)(pantalla2.getObject("mis2"));
            
               mis1.setText("Dades incorrectes: Nom,primer cognom i identificador son obligatoris."); 
               mis2.setText("La data s'ha d'introdur amb el format entre parentesis");
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                    
                                       new ActionListener()    
                                       
                                       {
                                       
                                       
                                          public void actionPerformed(ActionEvent ae) 
                                          
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("error"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
            
               catch(Exception e) {        
               
               
                  System.err.println("(ControlAltaParticipant5)Error: " + e.getMessage());
               
               }
         
            docFile2=null;
         
         }
      
      }
   
   }