   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Pesa.RelacioImatgesPesa;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Imatge.Imatge;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder consultar la info d'una pesa del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlConsultaPesa
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean consultaSenseProblemes;
      String nomPesa,duradaPesa,procedenciaPesa,autorPesa,dataCreacioPesa,descripcioPesa;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre consultar informacio sobre peces. 
   */
      public ControlConsultaPesa()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_consultaPesa.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlConsultaPesa()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaConsultaPesa()
      
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(consultaSenseProblemes && campsBuits<5)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("consultaPesa"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatPesa.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             Pesa pesa = new Pesa();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomPesa.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomPesa);
                                                if(duradaPesa.compareToIgnoreCase("")!=0)op.afegirCampHora("durada",duradaPesa);
                                                if(procedenciaPesa.compareToIgnoreCase("")!=0)op.afegirCampText("procedencia",procedenciaPesa);
                                                if(autorPesa.compareToIgnoreCase("")!=0)op.afegirCampText("autor",autorPesa);
                                                if(dataCreacioPesa.compareToIgnoreCase("")!=0)op.afegirCampData("dataCreacio",dataCreacioPesa);
                                             
                                                RelacioPeces relacioPeces = new RelacioPeces();
                                                relacioPeces.obtePesaPerMultiplesCamps(op);
                                             
                                                while(relacioPeces.hiHaPeces())
                                                {
                                                
                                                   pesa=relacioPeces.obtePesa();
                                                
                                                   llistat.addItem(pesa.obteNom(),pesa.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 mostraPesa((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatPesa"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioPeces.destructorRelacioPeces();
                                                pesa.destructorPesa();
                                             
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                
                                                   System.err.println("(ControlConsultaPesa1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("consultaPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlConsultaPesa2)Error: " + e.getMessage());
            
            }
      
      }
   
   
      private void capturaIValidaDades()
      {
      
         consultaSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,durada,procedencia,autor,dataCreacio;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomPesa=((JTextField)(pantalla.getObject("valorNom"))).getText();
         durada=(JTextField)(pantalla.getObject("valorDurada"));
         duradaPesa=((JTextField)(pantalla.getObject("valorDurada"))).getText();
         procedencia=(JTextField)(pantalla.getObject("valorProcedencia"));
         procedenciaPesa=((JTextField)(pantalla.getObject("valorProcedencia"))).getText();
         autor=(JTextField)(pantalla.getObject("valorAutor"));
         autorPesa=((JTextField)(pantalla.getObject("valorAutor"))).getText();
         dataCreacio=(JTextField)(pantalla.getObject("valorDataCreacio"));
         dataCreacioPesa=((JTextField)(pantalla.getObject("valorDataCreacio"))).getText();
      
         if(nomPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(duradaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(procedenciaPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(autorPesa.compareToIgnoreCase("")==0) campsBuits++;
         if(dataCreacioPesa.compareToIgnoreCase("")==0) campsBuits++;
      
      	   //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomPesa)) consultaSenseProblemes=false;
         else
         {
         
            if(durada.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDurada(duradaPesa)) consultaSenseProblemes=false;
            else
            {
            
               if(procedencia.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(procedenciaPesa)) consultaSenseProblemes=false;
               else
               {
               
                  if(autor.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(autorPesa)) consultaSenseProblemes=false;
                  else
                  {
                  
                     if(dataCreacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataCreacioPesa)) consultaSenseProblemes=false;
                  
                  }
               
               }
            
            }
         
         }
      
         if(consultaSenseProblemes==false | campsBuits==5)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlConsultaPesa3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void mostraPesa(final int identificadorPesa)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_resultatConsultaPesa.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar;
         JTextField camp;
         JTextArea camp2;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Pesa Pesa = RelacioPeces.obtePesaPerIdentificadorPesa(identificadorPesa);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Pesa.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDurada"));
            camp.setText(Pesa.obteDurada());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorProcedencia"));
            camp.setText(Pesa.obteProcedencia());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAutor"));
            camp.setText(Pesa.obteAutor());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataCreacio"));
            camp.setText(Pesa.obteDataCreacio());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorDescripcio"));
            camp2.setText(Pesa.obteDescripcio());
            camp2.setEnabled(false);
         
            RelacioImatgesPesa rel = new RelacioImatgesPesa();
            rel.obteImatgesPesa(identificadorPesa);
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("resultatConsultaPesa"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlConsultaPesa4)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   
   }