   package Entitats.Controladors;

   import Entitats.Controladors.ControlIdentificacio;
   import Entitats.UsuariActual.UsuariActual;
   import Entitats.Controladors.ControlAltaSoci;
   import Entitats.Controladors.ControlBaixaSoci;
   import Entitats.Controladors.ControlConsultaSoci;
   import Entitats.Controladors.ControlModificacioSoci;
   import Entitats.Controladors.ControlLlistatsSocis;
   import Entitats.Controladors.ControlAltaPesa;
   import Entitats.Controladors.ControlBaixaPesa;
   import Entitats.Controladors.ControlConsultaPesa;
   import Entitats.Controladors.ControlModificacioPesa;
   import Entitats.Controladors.ControlAltaActuacio;
   import Entitats.Controladors.ControlBaixaActuacio;
   import Entitats.Controladors.ControlConsultaActuacio;
   import Entitats.Controladors.ControlModificacioActuacio;
   import Entitats.Controladors.ControlGestioPropostesModificacio;
   import Entitats.Controladors.ControlGestioRegistresConnexio;
   import Entitats.Controladors.ControlGestioUsuarisAplicacio;
   import Entitats.Controladors.ControlEliminacioDadesSoci;
   import Entitats.Controladors.ControlAltaParticipant;
   import Entitats.Controladors.ControlBaixaParticipant;
   import Entitats.Controladors.ControlConsultaParticipant;
   import Entitats.Controladors.ControlModificacioParticipant;
   import Entitats.Controladors.ControlGaleria;
   import Entitats.Controladors.ControlDadesBBDD;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;

   public class ControlMenuPrincipal
   {
   
      private ControlIdentificacio controlIdentificacio;
      private ControlAltaSoci controlAltaSoci;
      private ControlBaixaSoci controlBaixaSoci;
      private ControlConsultaSoci controlConsultaSoci;
      private ControlModificacioSoci controlModificacioSoci;
      private ControlLlistatsSocis controlLlistatsSocis;
      private ControlAltaPesa controlAltaPesa;
      private ControlBaixaPesa controlBaixaPesa;
      private ControlConsultaPesa controlConsultaPesa;
      private ControlModificacioPesa controlModificacioPesa;
      private ControlAltaActuacio controlAltaActuacio;
      private ControlBaixaActuacio controlBaixaActuacio;
      private ControlConsultaActuacio controlConsultaActuacio;
      private ControlModificacioActuacio controlModificacioActuacio;
      private ControlGestioPropostesModificacio controlGestioPropostesModificacio;
      private ControlGestioRegistresConnexio controlGestioRegistresConnexio;
      private ControlGestioUsuarisAplicacio controlGestioUsuarisAplicacio;
      private ControlEliminacioDadesSoci controlEliminacioDadesSoci;
      private ControlAltaParticipant controlAltaParticipant;
      private ControlBaixaParticipant controlBaixaParticipant;
      private ControlConsultaParticipant controlConsultaParticipant;
      private ControlModificacioParticipant controlModificacioParticipant;
      private ControlDadesBBDD controlDadesBBDD;
      private UsuariActual usuariActual;
      private ControlGaleria controlGaleria;
   
   /*
   * Constructor de la classe. Crea i inicialitza instncies de les dems classes de control, 
   */
   
      public ControlMenuPrincipal()
      {
      
         usuariActual = new UsuariActual();
         controlIdentificacio = new ControlIdentificacio(usuariActual);
         controlAltaSoci = new ControlAltaSoci();
         controlBaixaSoci = new ControlBaixaSoci();
         controlConsultaSoci = new ControlConsultaSoci();
         controlModificacioSoci = new ControlModificacioSoci();
         controlLlistatsSocis = new ControlLlistatsSocis();
         controlAltaPesa = new ControlAltaPesa();
         controlBaixaPesa = new ControlBaixaPesa();
         controlConsultaPesa = new ControlConsultaPesa();
         controlModificacioPesa = new ControlModificacioPesa();
         controlAltaActuacio = new ControlAltaActuacio();
         controlBaixaActuacio = new ControlBaixaActuacio();
         controlConsultaActuacio = new ControlConsultaActuacio();
         controlModificacioActuacio = new ControlModificacioActuacio();
         controlGestioPropostesModificacio = new ControlGestioPropostesModificacio();
         controlGestioRegistresConnexio = new ControlGestioRegistresConnexio();
         controlGestioUsuarisAplicacio = new ControlGestioUsuarisAplicacio();
         controlEliminacioDadesSoci = new ControlEliminacioDadesSoci();
         controlAltaParticipant = new ControlAltaParticipant();
         controlBaixaParticipant = new ControlBaixaParticipant();
         controlConsultaParticipant = new ControlConsultaParticipant();
         controlModificacioParticipant = new ControlModificacioParticipant();  
         controlGaleria = new ControlGaleria();
         controlDadesBBDD = new ControlDadesBBDD();
      
      }
   
   /*
   *Mtode que instancia i inicialitza la pantalla del men principal de l'aplicaci i es mant a l'espera de que algun usuari cliqui
   *en alguna opci per emprendre les accions corresponents.
   */
   
      public void inicia()
      {
      
         String nomFitxer;
         JMenuItem sortir,altaSoci,baixaSoci,consultaSoci,modificacioSoci;
         JMenuItem llistatsSoci,altaActuacio,baixaActuacio,consultaActuacio;
         JMenuItem modificacioActuacio,altaPesa,baixaPesa,consultaPesa,modificacioPesa;
         JMenuItem identificarse,desidentificarse,propostesModificacio,registreConnexions;
         JMenuItem usuarisAplicacio,eliminarDadesSoci,altaParticipant,baixaParticipant;
         JMenuItem consultaParticipant,modificacioParticipant,obrirGaleria,bbdd;
         File docFile = new File(".././GUI/SGEC_GUI_main.jar");
         nomFitxer = docFile.getAbsolutePath();
      
         try
         {
         
            final AbaRenderer pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////MENU SORTIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            sortir=(JMenuItem)(pantalla.getObject("sortir"));
         
            sortir.addActionListener(
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("principal"))).dispose();
                                          sortir();
                                       
                                       }
                                    
                                    });
         
         ///////MENU ALTASOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            altaSoci=(JMenuItem)(pantalla.getObject("altaSoci"));
         
            altaSoci.addActionListener(
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          altaSoci();
                                       
                                       }
                                    
                                    });
         
         //////MENU BAIXASOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            baixaSoci=(JMenuItem)(pantalla.getObject("baixaSoci"));
         
            baixaSoci.addActionListener(
                                 
                                    new ActionListener()          
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          baixaSoci();
                                       
                                       }
                                    
                                    });
         
         //////MENU CONSULTASOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
            consultaSoci=(JMenuItem)(pantalla.getObject("consultaSoci"));
         
            consultaSoci.addActionListener(
                                 
                                    new ActionListener()      
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)        
                                       {
                                       
                                          consultaSoci();
                                       
                                       }
                                    
                                    });
         
         ///////MENU MODIFICACIOSOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            modificacioSoci=(JMenuItem)(pantalla.getObject("modificacioSoci"));
         
            modificacioSoci.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          modificacioSoci();
                                       
                                       }
                                    
                                    });
         
         ///////MENU LLISTATSSOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            llistatsSoci=(JMenuItem)(pantalla.getObject("llistatsSoci"));
         
            llistatsSoci.addActionListener(
                                 
                                    new ActionListener()      
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)      
                                       {
                                       
                                          llistatsSoci();
                                       
                                       }
                                    
                                    });
         
         //////MENU ALTAACTUACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
            altaActuacio=(JMenuItem)(pantalla.getObject("altaActuacio"));
         
            altaActuacio.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          altaActuacio();
                                       
                                       }
                                    
                                    });
         
         ///////MENU BAIXAACTUACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
            baixaActuacio=(JMenuItem)(pantalla.getObject("baixaActuacio"));
         
            baixaActuacio.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          baixaActuacio();
                                       
                                       }
                                    
                                    });
         
         /////////MENU CONSULTAACTUACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            consultaActuacio=(JMenuItem)(pantalla.getObject("consultaActuacio"));
         
            consultaActuacio.addActionListener(
                                 
                                    new ActionListener()     
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          consultaActuacio();
                                       
                                       }
                                    
                                    });
         
         ///////MENU MODIFICACIOACTUACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            modificacioActuacio=(JMenuItem)(pantalla.getObject("modificacioActuacio"));
         
            modificacioActuacio.addActionListener(
                                 
                                    new ActionListener()       
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          modificacioActuacio();
                                       
                                       }
                                    
                                    });
         
         ////////MENU ALTAPESA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            altaPesa=(JMenuItem)(pantalla.getObject("altaPesa"));
         
            altaPesa.addActionListener(
                                 
                                    new ActionListener()      
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          altaPesa();
                                       
                                       }
                                    
                                    });
         
         ////////MENU BAIXAPESA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
            baixaPesa=(JMenuItem)(pantalla.getObject("baixaPesa"));
         
            baixaPesa.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          baixaPesa();
                                       
                                       }
                                    
                                    });
         
         /////////MENU CONSULTAPESA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
            consultaPesa=(JMenuItem)(pantalla.getObject("consultaPesa"));
         
            consultaPesa.addActionListener(
                                 
                                    new ActionListener()       
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)      
                                       {
                                       
                                          consultaPesa();
                                       
                                       }
                                    
                                    });
         
         ////////MENU MODIFICACIOPESA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            modificacioPesa=(JMenuItem)(pantalla.getObject("modificacioPesa"));
         
            modificacioPesa.addActionListener(
                                 
                                    new ActionListener()        
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)         
                                       {
                                       
                                          modificacioPesa();
                                       
                                       }
                                    
                                    });
         
         /////////MENU IDENTIFICARSE\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            identificarse=(JMenuItem)(pantalla.getObject("identificarse"));
         
            identificarse.addActionListener(
                                 
                                    new ActionListener()       
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          identificarse();
                                       
                                       }
                                    
                                    });
         
         ////////MENU DESIDENTIFICARSE\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            desidentificarse=(JMenuItem)(pantalla.getObject("desidentificarse"));
         
            desidentificarse.addActionListener(
                                 
                                    new ActionListener()     
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          desidentificarse();
                                       
                                       }
                                    
                                    });
         
         ////////MENU PROPOSTESMODIFICACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            propostesModificacio=(JMenuItem)(pantalla.getObject("propostesModificacio"));
         
            propostesModificacio.addActionListener(
                                 
                                 
                                    new ActionListener()     
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          propostesModificacio();
                                       
                                       }
                                    
                                    });
         
         ////////MENU REGISTRECONNEXIONS\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            registreConnexions=(JMenuItem)(pantalla.getObject("registreConnexions"));
         
            registreConnexions.addActionListener(
                                 
                                    new ActionListener()     
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          registreConnexions();
                                       
                                       }
                                    
                                    });
         
         ////////MENU USUARISAPLICACIO\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            usuarisAplicacio=(JMenuItem)(pantalla.getObject("usuarisAplicacio"));
         
            usuarisAplicacio.addActionListener(
                                 
                                 
                                    new ActionListener()     
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          usuarisAplicacio();
                                       
                                       }
                                    
                                    });
         
         ////////MENU ELIMINARDADESSOCI\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            eliminarDadesSoci=(JMenuItem)(pantalla.getObject("eliminacioDadesSoci"));
         
            eliminarDadesSoci.addActionListener(
                                 
                                 
                                    new ActionListener()     
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          eliminarDadesSoci();
                                       
                                       }
                                    
                                    });
         
         
         ////////MENU ALTAPARTICIPANT\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            altaParticipant=(JMenuItem)(pantalla.getObject("altaParticipant"));
         
            altaParticipant.addActionListener(
                                 
                                 
                                 
                                    new ActionListener()     
                                    
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       
                                       {
                                       
                                          altaParticipant();
                                       
                                       }
                                    
                                    });
         
         ////////MENU BAIXAPARTICIPANT\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            baixaParticipant=(JMenuItem)(pantalla.getObject("baixaParticipant"));
         
            baixaParticipant.addActionListener(
                                 
                                 
                                 
                                 
                                    new ActionListener()     
                                    
                                    
                                    
                                    {
                                    
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       
                                       
                                       {
                                       
                                          baixaParticipant();
                                       
                                       }
                                    
                                    });
         
         ////////MENU CONSULTAPARTICIPANT\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            consultaParticipant=(JMenuItem)(pantalla.getObject("consultaParticipant"));
         
            consultaParticipant.addActionListener(
                                 
                                 
                                 
                                 
                                 
                                    new ActionListener()     
                                    
                                    
                                    
                                    
                                    {
                                    
                                    
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       
                                       
                                       
                                       {
                                       
                                          consultaParticipant();
                                       
                                       }
                                    
                                    });
         
         ////////MENU CONSULTAPARTICIPANT\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            modificacioParticipant=(JMenuItem)(pantalla.getObject("modificacioParticipant"));
         
            modificacioParticipant.addActionListener(
                                 
                                    new ActionListener()     
                                    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          modificacioParticipant();
                                       
                                       }
                                    
                                    });
         
         ////////MENU OBRIRGALERIA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            obrirGaleria=(JMenuItem)(pantalla.getObject("obrirGaleria"));
         
            obrirGaleria.addActionListener(
                                 
                                 
                                    new ActionListener()     
                                    
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          obrirGaleria();
                                       
                                       }
                                    
                                    });
         
         ////////MENU DADES BBDD\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
            bbdd=(JMenuItem)(pantalla.getObject("bbdd"));
         
            bbdd.addActionListener(
                                 
                                    new ActionListener()     
                                    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          bbdd();
                                       
                                       }
                                    
                                    });
         
         
         }
            catch(Exception e) {        
            
               System.err.println("(ControlMenuPrincipal)Error: " + e.getMessage());
            
            } 
      
      }
   
      private void sortir()
      {
      
         controlIdentificacio.destructorControlIdentificacio();
         controlAltaSoci.destructorControlAltaSoci();
         controlBaixaSoci.destructorControlBaixaSoci();
         controlConsultaSoci.destructorControlConsultaSoci();
         controlModificacioSoci.destructorControlModificacioSoci();
         controlLlistatsSocis.destructorControlLlistatsSocis();
         controlAltaPesa.destructorControlAltaPesa();
         controlBaixaPesa.destructorControlBaixaPesa();
         controlConsultaPesa.destructorControlConsultaPesa();
         controlModificacioPesa.destructorControlModificacioPesa();
         controlAltaActuacio.destructorControlAltaActuacio();
         controlBaixaActuacio.destructorControlBaixaActuacio();
         controlConsultaActuacio.destructorControlConsultaActuacio();
         controlModificacioActuacio.destructorControlModificacioActuacio();
         controlGestioPropostesModificacio.destructorControlGestioPropostesModificacio();
         controlGestioRegistresConnexio.destructorControlRegistresConnexio();
         controlGestioUsuarisAplicacio.destructorControlGestioUsuarisAplicacio();
         controlEliminacioDadesSoci.destructorControlEliminacioDadesSoci();
         controlAltaParticipant.destructorControlAltaParticipant();
         controlBaixaParticipant.destructorControlBaixaParticipant();
         controlConsultaParticipant.destructorControlConsultaParticipant();
         controlModificacioParticipant.destructorControlModificacioParticipant();
         controlGaleria.destructorControlGaleria();
         controlDadesBBDD.destructorControlDadesBBDD();
      
      }
   
      private void altaSoci()
      {
      
         if(usuariActual.nivellActual()==1 | usuariActual.nivellActual()==3)
         {
         
            controlAltaSoci.iniciaAltaSoci();
         
         }
         else
         {
         
            int[] i = {1,3,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void baixaSoci()
      {
      
         if(usuariActual.nivellActual()==1 | usuariActual.nivellActual()==3)
         {
         
            controlBaixaSoci.iniciaBaixaSoci();
         
         }
         else
         {
         
            int[] i = {1,3,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void consultaSoci()   
      {
      
         if(usuariActual.nivellActual()==0 | usuariActual.nivellActual()==1 | usuariActual.nivellActual()==3)
         {
         
            if(usuariActual.nivellActual()==0)
               controlConsultaSoci.iniciaConsultaSociLimitada(usuariActual);
            else
            {
               controlConsultaSoci.iniciaConsultaSoci(usuariActual);
            }
         }
         else
         {
         
            int[] i = {0,1,3,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void modificacioSoci()      
      {
      
         if(usuariActual.nivellActual()==1 | usuariActual.nivellActual()==3)
         {
         
            controlModificacioSoci.iniciaModificacioSoci();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void llistatsSoci()          
      {
      
         if(usuariActual.nivellActual()==1 | usuariActual.nivellActual()==3)
         {
         
            controlLlistatsSocis.iniciaCreacioLlistat();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void altaActuacio()     
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlAltaActuacio.iniciaAltaActuacio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
   
      private void baixaActuacio()      
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlBaixaActuacio.iniciaBaixaActuacio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
   
      private void consultaActuacio()          
      {
      
         controlConsultaActuacio.iniciaConsultaActuacio();
      
      }
   
   
      private void modificacioActuacio()          
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlModificacioActuacio.iniciaModificacioActuacio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void altaPesa()                
      {
      
         if(usuariActual.nivellActual()==2 | usuariActual.nivellActual()==3)
         {
         
            controlAltaPesa.iniciaAltaPesa();
         
         }
         else
         {
         
            int[] i = {2,3,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
   
   
      private void baixaPesa()                   
      {
      
         if(usuariActual.nivellActual()==2 | usuariActual.nivellActual()==3)
         {
         
            controlBaixaPesa.iniciaBaixaPesa();
         
         }
         else
         {
         
            int[] i = {2,3,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
   
   
      private void consultaPesa()                        
      {
      
         controlConsultaPesa.iniciaConsultaPesa();
      
      }
   
   
   
      private void modificacioPesa()          
      {
      
         if(usuariActual.nivellActual()==2 | usuariActual.nivellActual()==3)
         {
         
            controlModificacioPesa.iniciaModificacioPesa();
         
         }
         else
         {
         
            int[] i = {2,3,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void identificarse()
      {
      
         controlIdentificacio.identificaUsuari();
      
      }
   
      private void desidentificarse()
      {
      
         controlIdentificacio.desidentificaUsuari();
      
      }
   
      private void propostesModificacio()          
      
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlGestioPropostesModificacio.iniciaGestioPropostesModificacio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void registreConnexions()       
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlGestioRegistresConnexio.iniciaGestioRegistresConnexio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void usuarisAplicacio()       
      
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlGestioUsuarisAplicacio.iniciaGestioUsuarisAplicacio();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
   
      private void eliminarDadesSoci()       
      
      
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlEliminacioDadesSoci.iniciaEliminacioDadesSoci(usuariActual);
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void altaParticipant()              
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlAltaParticipant.iniciaAltaParticipant();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void baixaParticipant()
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlBaixaParticipant.iniciaBaixaParticipant();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }	
   
      private void consultaParticipant()
      
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlConsultaParticipant.iniciaConsultaParticipant();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void modificacioParticipant()                   
      {
      
         if(usuariActual.nivellActual()==3)
         {
         
            controlModificacioParticipant.iniciaModificacioParticipant();
         
         }
         else
         {
         
            int[] i = {3,0,0,0,0};
            controlIdentificacio.identificaUsuari(i);
         
         }
      
      }
   
      private void obrirGaleria()                   
      
      {
         controlGaleria.iniciaGaleria();
      }
   
      private void bbdd()                   
      
      {
      
         controlDadesBBDD.iniciaControlBBDD();
      
      }
   
   }