   package Entitats.Controladors;

   import java.io.File;
   import java.sql.Timestamp;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.util.Vector;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Persistencia.Llistat;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Participant.Participant;
   import Entitats.Actuacio.Actuacio;
   import Entitats.Actuacio.RelacioActuacions;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Actuacio.RelacioImatgesActuacio;	
   import Entitats.Eines.Navegador;
   import Entitats.Eines.ImageFileView;
   import Entitats.Eines.ImageFilter;
   import Entitats.Eines.ImagePreview;
   import Entitats.Eines.Utils;
   import Entitats.Eines.CopiaFitxer;
   import Entitats.Eines.Fitxer;
   import Entitats.Eines.Cadena;
   import Entitats.Eines.EscriuFitxerImatges;
   import java.sql.Timestamp;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder modificar la informacio
* d'una actuacio.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlModificacioActuacio
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean modificacioSenseProblemes;
      String dataActuacio,poblacioActuacio,llocActuacio,horaActuacio;
      int campsBuits;
      private Llistat participantsTemp;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari modificar una actuacio. 
   */
      public ControlModificacioActuacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_modificacioActuacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
         participantsTemp = new Llistat();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlModificacioActuacio()
      {
      
         pantalla = null;
         participantsTemp.destructorLlistat();
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaModificacioActuacio()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(modificacioSenseProblemes & campsBuits<4)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("modificacioActuacio"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatActuacio.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             Actuacio actuacio = new Actuacio();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(dataActuacio.compareToIgnoreCase("")!=0)op.afegirCampData("dataActuacio",dataActuacio);
                                                if(poblacioActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("poblacio",poblacioActuacio);
                                                if(llocActuacio.compareToIgnoreCase("")!=0)op.afegirCampText("lloc",llocActuacio);
                                                if(horaActuacio.compareToIgnoreCase("")!=0)op.afegirCampHoraSenseSegons("horaInici",horaActuacio);
                                             
                                                RelacioActuacions relacioActuacions = new RelacioActuacions();
                                                relacioActuacions.obteActuacioPerMultiplesCamps(op);
                                             
                                                while(relacioActuacions.hiHaActuacions())
                                                {
                                                
                                                   actuacio=relacioActuacions.obteActuacio();
                                                
                                                   llistat.addItem(actuacio.obteLloc()+" , "+actuacio.obteData(),actuacio.obteIdentificador());
                                                   elementsTrobats++;
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 modificaActuacio((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatActuacio"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioActuacions.destructorRelacioActuacions();
                                                actuacio.destructorActuacio();
                                             
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlModificacioActuacio1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("modificacioActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlModificacioActuacio2)Error: " + e.getMessage());
            
            }
      
      }
   
   
   
      private void capturaIValidaDades()
      {
      
         modificacioSenseProblemes = true;
         campsBuits=0;
      
         JTextField data,poblacio,lloc,hora;
      
         data=(JTextField)(pantalla.getObject("valorData"));
         dataActuacio=((JTextField)(pantalla.getObject("valorData"))).getText();
         poblacio=(JTextField)(pantalla.getObject("valorPoblacio"));
         poblacioActuacio=((JTextField)(pantalla.getObject("valorPoblacio"))).getText();
         lloc=(JTextField)(pantalla.getObject("valorLloc"));
         llocActuacio=((JTextField)(pantalla.getObject("valorLloc"))).getText();
         hora=(JTextField)(pantalla.getObject("valorHora"));
         horaActuacio=((JTextField)(pantalla.getObject("valorHora"))).getText();
      
         if(dataActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(poblacioActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(llocActuacio.compareToIgnoreCase("")==0) campsBuits++;
         if(horaActuacio.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(data.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataActuacio)) modificacioSenseProblemes=false;
         else
         {
         
            if(poblacio.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(poblacioActuacio)) modificacioSenseProblemes=false;
            else
            {
            
               if(lloc.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(llocActuacio)) modificacioSenseProblemes=false;
               else
               {
               
                  if(hora.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaHora(horaActuacio)) modificacioSenseProblemes=false;
               
               }
            
            }
         
         }
      
         if(modificacioSenseProblemes==false | campsBuits==4)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlModificacioActuacio3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
   
      private void modificaActuacio(final int identificadorActuacio)
      
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_novesDadesModificacioActuacio.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar,eliminarPesa,afegirPesa,eliminarParticipant,afegirParticipant,galeria,afegir,obrir,eliminar;
         JTextField camp;
         JTextArea camp2;
         JSSComboBox pecesDisponibles,participantsDisponibles;
         final JList pecesActuacio,participantsActuacio,llistatImatges;
         campsBuits = 0;
      
         final Fitxer arxiu = new Fitxer();
         final Fitxer directoriDesti = new Fitxer();
         final Fitxer fitxerDesti = new Fitxer();
      
         final Cadena rutaImatge = new Cadena();
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            pecesDisponibles = (JSSComboBox)(pantalla3.getObject("JSSComboBox1"));
            pecesActuacio = (JList)(pantalla3.getObject("JList1"));
            participantsDisponibles = (JSSComboBox)(pantalla3.getObject("JSSComboBox2"));
            participantsActuacio = (JList)(pantalla3.getObject("JList2"));
         
            RelacioPeces rp = new RelacioPeces();
            rp.obteTotesLesPeces();
         
            Pesa pesa = new Pesa();
         
            while(rp.hiHaPeces())
            {
            
               pesa = rp.obtePesa();
               pecesDisponibles.addItem(pesa.obteNom(),pesa.obteIdentificador());
            
            }
         
            pecesDisponibles.setSelectedValue((long)0);
         
            pesa.destructorPesa();	
            rp.destructorRelacioPeces();
         
            RelacioParticipants rpa = new RelacioParticipants();
            rpa.obteTotsElsParticipants();
         
            Participant participant = new Participant();
         
            while(rpa.hiHaParticipants())
            {
            
               participant = rpa.obteParticipant();
               participantsDisponibles.addItem(participant.obteCognom1()+" "+participant.obteCognom2()+" ,"+participant.obteNom(),participant.obteNumSoci());
            
            }
         
            participantsDisponibles.setSelectedValue((long)0);
         
            participant.destructorParticipant();	
            rpa.destructorRelacioParticipants();
         
            final Actuacio Actuacio = RelacioActuacions.obteActuacioPerIdentificadorActuacio(identificadorActuacio);
         
            camp=(JTextField)(pantalla3.getObject("valorData"));
            camp.setText(Actuacio.obteData());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorPoblacio"));
            camp.setText(Actuacio.obtePoblacio());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorLloc"));
            camp.setText(Actuacio.obteLloc());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorHora"));
            camp.setText(Actuacio.obteHoraInici());
            camp.setEnabled(false);
            camp2=(JTextArea)(pantalla3.getObject("valorObservacions"));
            camp2.setText(Actuacio.obteObservacions());
            camp2.setEnabled(false);
         
            final Vector elementsLlistat = new Vector();
            final Vector elementsLlistatParticipants = new Vector();
            final Vector elementsLlistatImatges = new Vector();
         
            llistatImatges = (JList)(pantalla3.getObject("llistatImatges"));
            RelacioImatgesActuacio rel = new RelacioImatgesActuacio();
            rel.obteImatgesActuacio(Actuacio.obteIdentificador());
            while(rel.hiHaImatges())
            {
               Imatge imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge()); 
               elementsLlistatImatges.add(imatge.obteRuta());
            } 
         
            llistatImatges.setListData(elementsLlistatImatges);
         
            Actuacio.obtePeces();
         
            while(Actuacio.hiHaPeces())
            {
            
               elementsLlistat.add( RelacioPeces.obtePesaPerIdentificadorPesa(Actuacio.obtePesa()).obteNom() );
            
            }
         
            pecesActuacio.setListData(elementsLlistat);
         
            pecesActuacio.setSelectedIndex(0);
         
            Actuacio.obteParticipants();
         
            while(Actuacio.hiHaParticipants())
            {
               Participant aux = RelacioParticipants.obteParticipantPerNumSoci(Actuacio.obteParticipant());
               elementsLlistatParticipants.add( aux.obteCognom1()+" "+aux.obteCognom2()+" ,"+aux.obteNom() );
            }
         
            participantsActuacio.setListData(elementsLlistatParticipants);
         
            participantsActuacio.setSelectedIndex(0);
         
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("novesDadesModificacioActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
                        ///////////BOTO MODIFICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            modificar=(JButton)(pantalla3.getObject("modificar"));
         
            modificar.addActionListener(
                                 
                                    new ActionListener()                        
                                    {                             
                                    
                                       public void actionPerformed(ActionEvent ae)                                               
                                       {
                                       
                                          ObjectePersistencia op = new ObjectePersistencia();
                                       
                                          String dataActuacioModificat,poblacioActuacioModificat,llocActuacioModificat,horaActuacioModificat,observacionsActuacioModificat;
                                       
                                          dataActuacioModificat=((JTextField)(pantalla3.getObject("valorDataModificat"))).getText();
                                          poblacioActuacioModificat=((JTextField)(pantalla3.getObject("valorPoblacioModificat"))).getText();
                                          llocActuacioModificat=((JTextField)(pantalla3.getObject("valorLlocModificat"))).getText();
                                          horaActuacioModificat=((JTextField)(pantalla3.getObject("valorHoraModificat"))).getText();
                                          observacionsActuacioModificat=((JTextArea)(pantalla3.getObject("valorObservacionsModificat"))).getText();
                                       
                                          if(dataActuacioModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(poblacioActuacioModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(llocActuacioModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(horaActuacioModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(observacionsActuacioModificat.compareToIgnoreCase("")==0) campsBuits++;
                                       
                                          modificacioSenseProblemes=true;
                                       
                                          if(dataActuacioModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataActuacioModificat)) {modificacioSenseProblemes=false;}
                                          else
                                          {
                                          
                                             if(poblacioActuacioModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(poblacioActuacioModificat)) {modificacioSenseProblemes=false;}
                                             else
                                             {
                                             
                                                if(llocActuacioModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(llocActuacioModificat)) {modificacioSenseProblemes=false;}
                                                else
                                                {
                                                
                                                   if(horaActuacioModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaHora(horaActuacioModificat)) {modificacioSenseProblemes=false;}
                                                   else
                                                   {
                                                   
                                                      if(observacionsActuacioModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaDescripcio(observacionsActuacioModificat)) {modificacioSenseProblemes=false;}
                                                   }
                                                }
                                             }
                                          }
                                       
                                          if(!modificacioSenseProblemes)
                                          {
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()                            
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)                                        
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("dadesNoValides"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {        
                                                
                                                   System.err.println("(ControlModificacioActuacio4)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile4 = null;
                                          
                                          }
                                          
                                          else
                                          {
                                          
                                             ((JFrame)(pantalla3.getObject("novesDadesModificacioActuacio"))).dispose();
                                          
                                             if(campsBuits<5)
                                             {
                                             
                                                if( dataActuacioModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataActuacio", dataActuacioModificat);
                                                if( poblacioActuacioModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("poblacio",poblacioActuacioModificat);
                                                if( llocActuacioModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("lloc",llocActuacioModificat);
                                                if( horaActuacioModificat.compareToIgnoreCase("")!=0 ) op.afegirCampHoraSenseSegons("horaInici",horaActuacioModificat);
                                                if( observacionsActuacioModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("observacions",observacionsActuacioModificat);
                                             
                                             
                                                RelacioActuacions.actualitzaDiversosCampsActuacioPerIdentificadorActuacio(identificadorActuacio,op);
                                             
                                             }
                                          
                                             Actuacio actuacio = RelacioActuacions.obteActuacioPerIdentificadorActuacio(identificadorActuacio);
                                             actuacio.eliminaPeces();
                                             actuacio.eliminaParticipants();
                                          
                                             Llistat llistatPecesActuacio = new Llistat(elementsLlistat);
                                             ObjectePersistencia ope = new ObjectePersistencia();
                                             RelacioPeces rlp = new RelacioPeces();
                                          
                                             while(llistatPecesActuacio.hiHaElements())
                                             {
                                             
                                                ope.afegirCampText("nom",(String)llistatPecesActuacio.obtePrimerElement());
                                             
                                                rlp.obtePesaPerMultiplesCamps(ope);
                                             
                                                while(rlp.hiHaPeces())
                                                {
                                                
                                                   actuacio.afegeixPesa(rlp.obtePesa().obteIdentificador());
                                                
                                                }
                                             
                                                ope.destructorObjectePersistencia();
                                                ope = new ObjectePersistencia();
                                             
                                             }
                                          
                                             ope.destructorObjectePersistencia();
                                             //actuacio.destructorActuacio();
                                          
                                          	/////////////////////
                                          
                                             for(int i = 0;i<participantsTemp.quants();i++)
                                             {
                                                if((String)participantsTemp.obteElement(i)!="" & (String)participantsTemp.obteElement(i)!=" ")
                                                {
                                                   actuacio.afegeixParticipant(i);
                                                }
                                             }
                                          
                                             	/////////////////////
                                          
                                             actuacio.eliminaImatges();
                                          
                                             RelacioImatges relIm = new RelacioImatges();
                                             Imatge imatge = new Imatge();
                                          
                                             Llistat llistatImatgesActuacio = new Llistat(elementsLlistatImatges);
                                          
                                             while(llistatImatgesActuacio.hiHaElements())
                                             {
                                             
                                                imatge.estableixRuta((String)llistatImatgesActuacio.obtePrimerElement());                              
                                                actuacio.afegeixImatge(relIm.afegirImatge(imatge));
                                             
                                             }
                                          
                                             actuacio.destructorActuacio();
                                          
                                          	/////////////////////
                                          
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                     
                                                                        new ActionListener()    
                                                                        
                                                                        {
                                                                        
                                                                        
                                                                           public void actionPerformed(ActionEvent ae) 
                                                                           
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("operacioOK"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {   
                                                
                                                
                                                   System.err.println("(ControlModificacioActuacio5)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             actuacio.destructorActuacio();
                                             docFile4=null;
                                          
                                          }
                                       
                                          op.destructorObjectePersistencia();
                                       
                                       }
                                    
                                    });
         
              ///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            eliminarPesa=(JButton)(pantalla3.getObject("eliminarPesa"));
         
            eliminarPesa.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          elementsLlistat.remove(((JList)pantalla3.getObject("JList1")).getSelectedValue());
                                          pecesActuacio.setListData(elementsLlistat);
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            afegirPesa=(JButton)(pantalla3.getObject("afegirPesa"));
         
            afegirPesa.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          long seleccio = ((JSSComboBox)pantalla3.getObject("JSSComboBox1")).getSelectedValue();
                                          Pesa Pesa = RelacioPeces.obtePesaPerIdentificadorPesa((int)seleccio);
                                          if(!elementsLlistat.contains(Pesa.obteNom()))	
                                             elementsLlistat.add(Pesa.obteNom());
                                          Pesa.destructorPesa();
                                          pecesActuacio.setListData(elementsLlistat);
                                       
                                       }
                                    
                                    });
         
             ///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            eliminarParticipant=(JButton)(pantalla3.getObject("eliminarParticipant"));
         
            eliminarParticipant.addActionListener(
                                 
                                 
                                    new ActionListener()                 
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          /*elementsLlistatParticipants.remove(((JList)pantalla3.getObject("JList2")).getSelectedValue());
                                       		participantsActuacio.setListData(elementsLlistatParticipants);*/
                                       
                                          int seleccio = ((JList)pantalla3.getObject("JList2")).getSelectedIndex();
                                          if(seleccio>=0)
                                          {
                                             String valorAEliminar = (String)((JList)pantalla3.getObject("JList2")).getSelectedValue();
                                          //System.out.println(seleccio);
                                             elementsLlistatParticipants.removeElementAt(seleccio);
                                             int posicio = participantsTemp.buscaElement(valorAEliminar);
                                             System.out.println(posicio);
                                             if(posicio>0) participantsTemp.eliminaElement(posicio);
                                          	//participantsTemp.eliminaElement(valorAEliminar);
                                             participantsActuacio.setListData(elementsLlistatParticipants);
                                          }
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            afegirParticipant=(JButton)(pantalla3.getObject("afegirParticipant"));
         
            afegirParticipant.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          long seleccio = ((JSSComboBox)pantalla3.getObject("JSSComboBox2")).getSelectedValue();
                                          Participant Participant = RelacioParticipants.obteParticipantPerNumSoci((int)seleccio);
                                          if(!elementsLlistatParticipants.contains(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom()))	
                                          {
                                             elementsLlistatParticipants.add(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom());
                                             participantsTemp.afegeixAPosicio((String)(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom()),Participant.obteNumSoci());
                                          }
                                          Participant.destructorParticipant();
                                          participantsActuacio.setListData(elementsLlistatParticipants);
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO GALERIA\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            galeria=(JButton)(pantalla3.getObject("galeria"));
         
            galeria.addActionListener(
                                 
                                 
                                 
                                    new ActionListener()
                                    
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       
                                       {
                                       
                                          RelacioImatgesActuacio rel = new RelacioImatgesActuacio();
                                          rel.obteImatgesActuacio(Actuacio.obteIdentificador());
                                       
                                          Timestamp time = new Timestamp(System.currentTimeMillis());
                                       
                                          //assignem un nom al fitxer
                                          String nouFitxer = ""+(time.getTime()+time.getTime());
                                       
                                          EscriuFitxerImatges.EscriuFitxerActuacions(rel,nouFitxer);
                                       
                                          Navegador.obreURL("../Actuacio/"+nouFitxer+".htm");
                                       }
                                    
                                    });									
         
               ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
            obrir=(JButton)(pantalla3.getObject("obrir"));
         
            obrir.addActionListener(                                                        
                                 
                                 
                                    new ActionListener()                                                
                                    
                                    {                                  
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)                                         
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                             JFileChooser fc;
                                             fc = new JFileChooser();
                                          
                                             fc.addChoosableFileFilter(new ImageFilter());
                                             fc.setAcceptAllFileFilterUsed(false);
                                          
                                             fc.setFileView(new ImageFileView());
                                          
                                             fc.setAccessory(new ImagePreview(fc));
                                          
                                          
                                             int returnVal = fc.showDialog((JFrame)(pantalla3.getObject("novesDadesModificacioActuacio")),"Afegir");
                                          
                                             if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File directori = fc.getCurrentDirectory();
                                                arxiu.estableixFitxer(fc.getSelectedFile());
                                                String fitxer = arxiu.obteFitxer().getName();
                                                ((JTextField)(pantalla3.getObject("nomImatge"))).setText(fitxer);
                                             
                                                Timestamp time = new Timestamp(System.currentTimeMillis());
                                                String nouFitxer = (time.getTime()+time.getTime())+"--"+fitxer;
                                             
                                                directoriDesti.estableixFitxer(new File("../Galeria/actuacions/imatges/"));
                                                fitxerDesti.estableixFitxer(new File(directoriDesti.obteFitxer(), nouFitxer));
                                                rutaImatge.estableixCadena("../Galeria/actuacions/imatges/"+nouFitxer);
                                             
                                             } 
                                          
                                             fc.setSelectedFile(null);
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {        
                                             
                                             
                                             
                                             
                                             
                                                System.err.println("(ConsultaModificacioActuacio6)Error: " + e.getMessage());
                                             
                                             }
                                       
                                       }
                                    
                                    });		
         
              ///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            afegir=(JButton)(pantalla3.getObject("afegir"));
         
            afegir.addActionListener(
                                 
                                 
                                    new ActionListener()    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       {
                                          try
                                          {
                                          
                                             if(arxiu.obteFitxer()!=null)
                                             {
                                                Long checksumSrc = CopiaFitxer.copia(arxiu.obteFitxer(), fitxerDesti.obteFitxer());
                                             
                                                Long checksumDest = CopiaFitxer.creaChecksum(fitxerDesti.obteFitxer());
                                                if (!checksumSrc.equals(checksumDest)) {
                                                   System.err.println("(ControlModificacioActuacio7)Error: La copia del fitxer "+arxiu.obteFitxer().getName()+" ha fallat");
                                                } 
                                                else
                                                {	
                                                   if(!elementsLlistatImatges.contains("../Galeria/actuacions/imatges/"+fitxerDesti.obteFitxer().getName()))	
                                                   {
                                                      elementsLlistatImatges.add("../Galeria/actuacions/imatges/"+fitxerDesti.obteFitxer().getName());
                                                   }
                                                   llistatImatges.setListData(elementsLlistatImatges);
                                                }	
                                             
                                             }
                                             else throw new Exception ("Encara no has seleccionat cap fitxer!!");
                                          
                                          
                                          }
                                          
                                          
                                             catch(Exception e) {                                                     
                                             
                                             
                                                System.err.println("(ControlModificacioActuacio8)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });
         
            ///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
            eliminar=(JButton)(pantalla3.getObject("eliminar"));
         
            eliminar.addActionListener(
                                 
                                 
                                    new ActionListener()                 
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       {
                                       
                                          elementsLlistatImatges.remove(((JList)pantalla3.getObject("llistatImatges")).getSelectedValue());
                                          llistatImatges.setListData(elementsLlistatImatges);
                                       
                                       }
                                    
                                    });
         
         
         }
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlModificacioActuacio9)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }