   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Participant.Participant;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Soci.RelacioImatgesSoci;
   import Entitats.Soci.Soci;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder modificar la informacio
* d'un participant.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlModificacioParticipant
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean modificacioSenseProblemes;
      String nomParticipant,cognom1Participant,cognom2Participant,identificadorPersonalParticipant,adresaParticipant;
      String telefonParticipant,dataNaixementParticipant,numSoci,dataAltaParticipant;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari modificar un participant. 
   */
      public ControlModificacioParticipant()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_modificacioParticipant.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlModificacioParticipant()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaModificacioParticipant()
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(modificacioSenseProblemes && campsBuits<9)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("modificacioParticipant"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatParticipant.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             String nomICognoms="";
                                             Participant participant = new Participant();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomParticipant);
                                                if(cognom1Participant.compareToIgnoreCase("")!=0)op.afegirCampText("cognom1",cognom1Participant);
                                                if(cognom2Participant.compareToIgnoreCase("")!=0)op.afegirCampText("cognom2",cognom2Participant);
                                                if(identificadorPersonalParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("identificadorPersonal",identificadorPersonalParticipant);
                                                if(adresaParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("adresa",adresaParticipant);
                                                if(telefonParticipant.compareToIgnoreCase("")!=0)op.afegirCampNumeric("telefon",Integer.parseInt(telefonParticipant));
                                                if(dataNaixementParticipant.compareToIgnoreCase("")!=0)op.afegirCampData("dataNaixement",dataNaixementParticipant);
                                                if(numSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("numSoci",Integer.parseInt(numSoci));
                                                if(dataAltaParticipant.compareToIgnoreCase("")!=0)op.afegirCampData("dataAltaParticipant",dataAltaParticipant);
                                             
                                                RelacioParticipants relacioParticipants = new RelacioParticipants();
                                                relacioParticipants.obteParticipantPerMultiplesCamps(op);
                                             
                                                while(relacioParticipants.hiHaParticipants())
                                                {
                                                
                                                   nomICognoms="";
                                                   participant=relacioParticipants.obteParticipant();
                                                   if(participant.esActiu())
                                                   {
                                                      nomICognoms+=participant.obteCognom1()+" "+participant.obteCognom2()+" , "+participant.obteNom();
                                                      llistat.addItem(nomICognoms,participant.obteNumSoci());
                                                      elementsTrobats++;
                                                   }
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 modificaParticipant((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioParticipants.destructorRelacioParticipants();
                                                participant.destructorParticipant();
                                             
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {      
                                                
                                                   System.err.println("(ControlModificacioParticipant1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("modificacioParticipant"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlModificacioParticipant2)Error: " + e.getMessage());
            
            }
      
      }
   
   
   
      private void capturaIValidaDades()
      
      {
      
         modificacioSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,num,dataAlta;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomParticipant=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1=(JTextField)(pantalla.getObject("valorCognom1"));
         cognom1Participant=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2=(JTextField)(pantalla.getObject("valorCognom2"));
         cognom2Participant=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonal=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
         identificadorPersonalParticipant=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresa=(JTextField)(pantalla.getObject("valorAdresa"));
         adresaParticipant=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefon=(JTextField)(pantalla.getObject("valorTelefon"));
         telefonParticipant=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixement=(JTextField)(pantalla.getObject("valorDataNaixement"));
         dataNaixementParticipant=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
         num=(JTextField)(pantalla.getObject("valorNumSoci"));
         numSoci=((JTextField)(pantalla.getObject("valorNumSoci"))).getText();
         dataAlta=(JTextField)(pantalla.getObject("valorDataAltaParticipant"));
         dataAltaParticipant=((JTextField)(pantalla.getObject("valorDataAltaParticipant"))).getText();
      
         if(nomParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom1Participant.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom2Participant.compareToIgnoreCase("")==0) campsBuits++;
         if(identificadorPersonalParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(adresaParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(telefonParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(dataNaixementParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(numSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(dataAltaParticipant.compareToIgnoreCase("")==0) campsBuits++;
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomParticipant)) modificacioSenseProblemes=false;
         else
         {
         
            if(cognom1.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1Participant)) modificacioSenseProblemes=false;
            else
            {
            
               if(cognom2.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2Participant)) modificacioSenseProblemes=false;
               else
               {
               
                  if(identificadorPersonal.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalParticipant)) modificacioSenseProblemes=false;
                  else
                  {
                  
                     if(adresa.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaParticipant)) modificacioSenseProblemes=false;
                     else
                     {
                     
                        if(telefon.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonParticipant)) modificacioSenseProblemes=false;
                        else
                        {
                        
                           if(dataNaixement.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementParticipant)) modificacioSenseProblemes=false;
                           else
                           {
                           
                              if(num.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaXifra(numSoci)) modificacioSenseProblemes=false;
                              else
                              {
                              
                                 if(dataAlta.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataAltaParticipant)) modificacioSenseProblemes=false;
                              
                              }
                           }
                        }
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(modificacioSenseProblemes==false | campsBuits==9)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlModificacioParticipant3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
         else
         {
         
            if(campsBuits==8 & dataAlta.getText().compareToIgnoreCase("")!=0)
            {
               modificacioSenseProblemes = false;
               File docFile21 = new File(".././GUI/SGEC_GUI_error.jar");
               String nomFitxer21 = docFile21.getAbsolutePath();
               JButton acceptar;
            
               try
               {
               
                  final AbaRenderer pantalla21 = new AbaRenderer(nomFitxer21, false, null);
                  pantalla21.load();
                  pantalla21.renderInterface();
               
                  JLabel mis1 =(JLabel)(pantalla21.getObject("mis1"));
                  mis1.setText("No es buscar pot nomes per el");
                  JLabel mis2 =(JLabel)(pantalla21.getObject("mis2"));
                  mis2.setText("camp \"Data Alta Participant\"");
               
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
                  acceptar=(JButton)(pantalla21.getObject("acceptar"));
               
                  acceptar.addActionListener(
                                       
                                       
                                       
                                       
                                          new ActionListener()                 
                                          
                                          
                                          
                                          {
                                          
                                          
                                          
                                          
                                             public void actionPerformed(ActionEvent ae)       
                                             
                                             
                                             
                                             {
                                             
                                                ((JFrame)(pantalla21.getObject("error"))).dispose();
                                             
                                             }
                                          
                                          });
               
               }
               
               
               
               
                  catch(Exception e) {        
                  
                  
                  
                  
                     System.err.println("(ControlModificacioParticipant4)Error: " + e.getMessage());
                  
                  }
            
               docFile21 = null;
            
            }
         
         }
      }
   
   
      private void modificaParticipant(final int numSoci)
      
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_novesDadesModificacioParticipant.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar;
         JTextField camp;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Participant Participant = RelacioParticipants.obteParticipantPerNumSoci(numSoci);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Participant.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom1"));
            camp.setText(Participant.obteCognom1());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom2"));
            camp.setText(Participant.obteCognom2());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorIdentificadorPersonal"));
            camp.setText(Participant.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAdresa"));
            camp.setText(Participant.obteAdresa());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorTelefon"));
            camp.setText(""+Participant.obteTelefon()+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataNaixement"));
            camp.setText(Participant.obteDataNaixement());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorNumSoci"));
            camp.setText(""+numSoci+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataAltaParticipant"));
            camp.setText(Participant.obteDataAltaParticipant());
            camp.setEnabled(false);
         
            RelacioImatgesSoci rel = new RelacioImatgesSoci();
            rel.obteImatgesSoci(numSoci);
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
            rel.destructorRelacioImatgesSoci();
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("novesDadesModificacioParticipant"))).dispose();
                                       
                                       }
                                    
                                    });
         
                        ///////////BOTO MODIFICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
            modificar=(JButton)(pantalla3.getObject("modificar"));
         
            modificar.addActionListener(
                                 
                                    new ActionListener()                        
                                    {                             
                                    
                                       public void actionPerformed(ActionEvent ae)                                               
                                       {
                                       
                                          ObjectePersistencia op = new ObjectePersistencia();
                                       
                                          String nomParticipantModificat,cognom1ParticipantModificat,cognom2ParticipantModificat,identificadorPersonalParticipantModificat,adresaParticipantModificat;
                                          String telefonParticipantModificat,dataNaixementParticipantModificat,dataAltaParticipantModificat;
                                       
                                          nomParticipantModificat=((JTextField)(pantalla3.getObject("valorNomModificat"))).getText();
                                          cognom1ParticipantModificat=((JTextField)(pantalla3.getObject("valorCognom1Modificat"))).getText();
                                          cognom2ParticipantModificat=((JTextField)(pantalla3.getObject("valorCognom2Modificat"))).getText();
                                          identificadorPersonalParticipantModificat=((JTextField)(pantalla3.getObject("valorIdentificadorPersonalModificat"))).getText();
                                          adresaParticipantModificat=((JTextField)(pantalla3.getObject("valorAdresaModificat"))).getText();
                                          telefonParticipantModificat=((JTextField)(pantalla3.getObject("valorTelefonModificat"))).getText();
                                          dataNaixementParticipantModificat=((JTextField)(pantalla3.getObject("valorDataNaixementModificat"))).getText();
                                          dataAltaParticipantModificat=((JTextField)(pantalla3.getObject("valorDataAltaParticipantModificat"))).getText();
                                       
                                          modificacioSenseProblemes=true;
                                          campsBuits=0;
                                          if(nomParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomParticipantModificat)) {modificacioSenseProblemes=false;}
                                          else
                                          {
                                          
                                             if(cognom1ParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1ParticipantModificat)) {modificacioSenseProblemes=false;}
                                             else
                                             {
                                             
                                                if(cognom2ParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2ParticipantModificat)) {modificacioSenseProblemes=false;}
                                                {
                                                
                                                   if(identificadorPersonalParticipantModificat.compareToIgnoreCase("")!=0 && (!ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalParticipantModificat) | !RelacioParticipants.noExisteix(identificadorPersonalParticipantModificat)) ) {modificacioSenseProblemes=false;}
                                                   {
                                                   
                                                      if(adresaParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaParticipantModificat)) {modificacioSenseProblemes=false;}
                                                      else
                                                      {
                                                      
                                                         if(telefonParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonParticipantModificat)) {modificacioSenseProblemes=false;}
                                                         else
                                                         {
                                                         
                                                            if(dataNaixementParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementParticipantModificat)) {modificacioSenseProblemes=false;}
                                                            else
                                                            {
                                                            
                                                               if(dataAltaParticipantModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataAltaParticipantModificat)) {modificacioSenseProblemes=false;}
                                                            }
                                                         }
                                                      
                                                      }
                                                   
                                                   }
                                                
                                                }
                                             
                                             }
                                          
                                          }
                                       
                                          if(nomParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom1ParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom2ParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(identificadorPersonalParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(adresaParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(telefonParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(dataNaixementParticipantModificat.compareToIgnoreCase("")==0) campsBuits++; 
                                          if(dataAltaParticipantModificat.compareToIgnoreCase("")==0) campsBuits++;
                                       
                                          if(!modificacioSenseProblemes | campsBuits==8)
                                          {
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()                            
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)                                        
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("dadesNoValides"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {        
                                                
                                                   System.err.println("(ControlModificacioParticipant5)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile4 = null;
                                          
                                          }
                                          
                                          else
                                          {
                                          
                                             ((JFrame)(pantalla3.getObject("novesDadesModificacioParticipant"))).dispose();
                                          
                                             if( nomParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("nom",nomParticipantModificat);
                                             if( cognom1ParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom1",cognom1ParticipantModificat);
                                             if( cognom2ParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom2",cognom2ParticipantModificat);
                                             if( identificadorPersonalParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("identificadorPersonal",identificadorPersonalParticipantModificat);
                                             if( adresaParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("adresa",adresaParticipantModificat);
                                             if( telefonParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampNumeric("telefon",Integer.parseInt(telefonParticipantModificat));
                                             if( dataNaixementParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataNaixement",dataNaixementParticipantModificat);
                                             if( dataAltaParticipantModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataAltaParticipant",dataAltaParticipantModificat);
                                          
                                             if(RelacioParticipants.actualitzaDiversosCampsParticipantPerNumSoci(numSoci,op))
                                             {
                                             
                                                File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                                String nomFitxer5 = docFile5.getAbsolutePath();
                                                JButton acceptar;
                                             
                                                try
                                                {
                                                
                                                   final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                   pantalla5.load();
                                                   pantalla5.renderInterface();
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
                                                   acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                        
                                                                        
                                                                           new ActionListener()                 
                                                                           
                                                                           
                                                                           {
                                                                           
                                                                           
                                                                           
                                                                              public void actionPerformed(ActionEvent ae)       
                                                                              
                                                                              
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                                
                                                
                                                
                                                   catch(Exception e) {        
                                                   
                                                   
                                                   
                                                      System.err.println("(ControlModificacioParticipant6)Error: " + e.getMessage());
                                                   
                                                   }
                                             
                                                docFile5 = null;
                                             }
                                          
                                          }
                                       
                                          op.destructorObjectePersistencia();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlModificacioParticipant7)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   }