   package Entitats.Controladors;

   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder reactivar un soci
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlTornadaSoci
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
      String nomSoci,cognom1Soci,cognom2Soci,identificadorPersonalSoci,adresaSoci;
      String telefonSoci,dataNaixementSoci;
      boolean altaSenseProblemes;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari reactivar un soci. 
   */
      public ControlTornadaSoci()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_tornadaSoci.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlTornadaSoci()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   *@param Soci Objecte soci amb la info del soci a reactivar
   */
      public void iniciaTornadaSoci(Soci Soci)
      {
      
         JButton acceptar,cancelar;
         JTextField camp;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            camp=(JTextField)(pantalla.getObject("valorNom"));
            camp.setText(Soci.obteNom());
            camp=(JTextField)(pantalla.getObject("valorCognom1"));
            camp.setText(Soci.obteCognom1());
            camp=(JTextField)(pantalla.getObject("valorCognom2"));
            camp.setText(Soci.obteCognom2());
            camp=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
            identificadorPersonalSoci=Soci.obteIdentificadorPersonal();
            camp.setText(Soci.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla.getObject("valorAdresa"));
            camp.setText(Soci.obteAdresa());
            camp=(JTextField)(pantalla.getObject("valorTelefon"));
            camp.setText(""+Soci.obteTelefon()+"");
            camp=(JTextField)(pantalla.getObject("valorDataNaixement"));
            camp.setText(Soci.obteDataNaixement());
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaNovesDades();
                                          if(altaSenseProblemes)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("tornadaSoci"))).dispose();
                                             ObjectePersistencia op = new ObjectePersistencia();
                                             op.afegirCampText("nom",nomSoci);
                                             op.afegirCampText("cognom1",cognom1Soci);
                                             op.afegirCampText("cognom2",cognom2Soci);
                                             op.afegirCampText("adresa",adresaSoci);
                                             op.afegirCampNumeric("telefon",Integer.parseInt(telefonSoci));
                                             op.afegirCampData("dataNaixement",dataNaixementSoci);
                                             op.afegirCampNumeric("actiu",1);
                                          
                                             if(RelacioSocis.actualitzaDiversosCampsSociPerIdentificadorPersonal(identificadorPersonalSoci,op))
                                             {
                                             
                                                File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                                String nomFitxer5 = docFile5.getAbsolutePath();
                                                JButton acceptar;
                                             
                                                try
                                                {
                                                
                                                   final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                   pantalla5.load();
                                                   pantalla5.renderInterface();
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                   acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()                 
                                                                           
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae)       
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });									
                                                
                                                }
                                                
                                                   catch(Exception e) {        
                                                   
                                                      System.err.println("(ControlTornadaSoci1)Error: " + e.getMessage());
                                                   
                                                   }
                                             
                                                docFile5 = null;
                                             
                                             }
                                             op.destructorObjectePersistencia();
                                          
                                          }
                                       
                                       }
                                    });
         
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("tornadaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
            camp = null;
         
         } 
            catch(Exception e) {        
            
               System.err.println("(ControlTornadaSoci2)Error: " + e.getMessage());
            
            }
      
      }
   
      private void capturaIValidaNovesDades()
      {
      
         altaSenseProblemes = true;
      
         nomSoci=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1Soci=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2Soci=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         adresaSoci=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefonSoci=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixementSoci=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
      
         //validar dades
      
         if(!ValidadorFormulariEntrada.validaNom(nomSoci)) altaSenseProblemes=false;
         else
         {
         
            if(!ValidadorFormulariEntrada.validaNom(cognom1Soci)) altaSenseProblemes=false;
            else
            {
            
               if(!ValidadorFormulariEntrada.validaNom(cognom2Soci)) altaSenseProblemes=false;
               else
               {
               
                  if(!ValidadorFormulariEntrada.validaAdresa(adresaSoci)) altaSenseProblemes=false;
                  else
                  {
                  
                     if(!ValidadorFormulariEntrada.validaTelefon(telefonSoci)) altaSenseProblemes=false;
                     else
                     {
                     
                        if(!ValidadorFormulariEntrada.validaData(dataNaixementSoci)) altaSenseProblemes=false;
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(altaSenseProblemes==false)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()    
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae) 
                                          
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {     
               
                  System.err.println("(ControlTornadaSoci3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
   }