   package Entitats.Eines;

   import java.awt.BorderLayout; 
   import java.awt.Component;
   import java.awt.Dimension;
   import java.awt.Graphics;
   import java.awt.event.AdjustmentEvent;
   import java.awt.event.AdjustmentListener;
   import java.awt.event.WindowAdapter;
   import java.awt.event.WindowEvent;

   import javax.swing.JFrame;
   import javax.swing.JScrollBar;
   import javax.swing.JScrollPane;
   import javax.swing.JTable;
   import javax.swing.ListSelectionModel;
   import javax.swing.UIManager;
   import javax.swing.table.AbstractTableModel;


   public class Taula extends JFrame {
      Object[][] data;
   
      Object[] column;
   
      JTable table;
   
      public Taula(final Object[][] data,final Object[] column) {
      
         super("Llistat de socis");
      
         this.data = data;
         this.column = column;
      
         AbstractTableModel model = 
            new AbstractTableModel() {
               public int getColumnCount() {
                  return column.length;
               }
            
               public int getRowCount() {
                  return data.length;
               }
            
               public String getColumnName(int col) {
                  return (String) column[col];
               }
            
               public Object getValueAt(int row, int col) {
                  return data[row][col];
               }
            
               public void setValueAt(Object obj, int row, int col) {
                  data[row][col] = obj;
               }
            
               public boolean CellEditable(int row, int col) {
                  return true;
               }
            };
         table = new JTable(model);
         table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
         table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      
         JScrollPane scroll = new JScrollPane(table);
         scroll
            .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
         final JScrollBar bar1 = scroll.getHorizontalScrollBar();
         scroll.setPreferredSize(new Dimension(400, 100));
         getContentPane().add(scroll, BorderLayout.CENTER);
      }
   
      public AbstractTableModel obteModel()
      {
         return (AbstractTableModel)table.getModel();
      }
   
   }
