   package Entitats.Persistencia;

/**
* Classe que ens permet treballar amb un estandard a l'hora de demanar informacio al sistema
* i manipular-la.
*@author Jordi Moles i Blanco, Mar 2005
*/

   public class Resultat
   {
   
      private String valor;
   
   /**
   * Constructor de la classe
   */
      public Resultat()
      {
      
         valor="";
      
      }
   
   /**
   * Metode que ens permet afegir un valor i un nom relacionat a aquest valor
   *param titol String amb el nom que li volem donar a la informacio
   *param valor String amb la informacio
   */
      public void afegeixElement(String titol,String valor)
      {
      
         this.valor=this.valor+" ;;"+titol+";"+valor+";";
      
      }
   
   /**
   * Metode que ens permet afegir un valor i un nom relacionat a aquest valor
   *param titol String amb el nom que li volem donar a la informacio
   *param valor Enter amb la informacio
   */        
      public void afegeixElement(String titol,int valor)
      
      {
      
         this.valor=this.valor+" ;;"+titol+";"+valor+";";
      
      }
   
   /**
   * Metode que ens permet obtenir tota la informacio que l'objecte conte 
   * en forma de String, amb el seguent format: ;;titol informacio;informacio; ;;titol inf.....
   *@return String amb tota la informacio que l'objecte conte
   */
      public String obteCadenaResultat()
      {
      
         return valor;
      
      }
   
   /**
   * Metode que ens permet recuperar una part de la informacio que l'objecte conte
   * a partir del nom d'aquesta
   *@param element Nom de la pesa d'informacio que necessitem
   *@return Object del java amb la informacio associada a la part anomenada "element"
   */
      public Object obteElement(String element)
      {
         int posicio1,posicio2;
      
         Object objecte;
      
         objecte=null;
         posicio1 = 0;
         posicio2 = 0;
         valor=valor.toLowerCase();
         posicio1=valor.indexOf(";;"+element.trim().toLowerCase()+";");
         if(posicio1<0) 
            return null;
         posicio1+=2;
         posicio2=valor.indexOf(";",posicio1+element.length()+1);
         objecte=valor.substring(posicio1+element.length()+1,posicio2);
         return objecte;
      
      }
   
   }